#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 60 "../../../gccfe/gnu/c-parse.y"
#include "config.h"
#include "system.h"
#include <setjmp.h>

#include "tree.h"
#include "input.h"
#include "c-lex.h"
#include "c-tree.h"
#include "flags.h"
#include "output.h"
#include "toplev.h"



#ifdef MULTIBYTE_CHARS
#include <locale.h>
#endif

#include <upc-act.h>


/* Since parsers are distinct for each language, put the language string
   definition here.  */
const char * const language_string = "GNU UPC";

/* Like YYERROR but do call yyerror.  */
#define YYERROR1 { yyerror ("syntax error"); YYERROR; }

/* Cause the `yydebug' variable to be defined.  */
#define YYDEBUG 1
#line 94 "../../../gccfe/gnu/c-parse.y"
typedef union {long itype; tree ttype; enum tree_code code;
	char *filename; int lineno; int ends_in_label; } YYSTYPE;
#line 224 "../../../gccfe/gnu/c-parse.y"
/* Number of statements (loosely speaking) and compound statements 
   seen so far.  */
static int stmt_count;
static int compstmt_count;
  
/* Input file and line number of the end of the body of last simple_if;
   used by the stmt-rule immediately after simple_if returns.  */
static char *if_stmt_file;
static int if_stmt_line;

/* List of types and structure classes of the current declaration.  */
static tree current_declspecs = NULL_TREE;
static tree prefix_attributes = NULL_TREE;

/* Stack of saved values of current_declspecs and prefix_attributes.  */
static tree declspec_stack;

/* 1 if we explained undeclared var errors.  */
static int undeclared_variable_notice;


/* Tell yyparse how to print a token's value, if yydebug is set.  */

#define YYPRINT(FILE,YYCHAR,YYLVAL) yyprint(FILE,YYCHAR,YYLVAL)
extern void yyprint			PARAMS ((FILE *, int, YYSTYPE));
#line 77 "c-parse.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define TYPENAME 258
#define SCSPEC 259
#define TYPESPEC 260
#define TYPE_QUAL 261
#define CONSTANT 262
#define STRING 263
#define ELLIPSIS 264
#define SIZEOF 265
#define ENUM 266
#define STRUCT 267
#define UNION 268
#define IF 269
#define ELSE 270
#define WHILE 271
#define DO 272
#define FOR 273
#define SWITCH 274
#define CASE 275
#define DEFAULT 276
#define BREAK 277
#define CONTINUE 278
#define RETURN 279
#define GOTO 280
#define ASM_KEYWORD 281
#define TYPEOF 282
#define ALIGNOF 283
#define ATTRIBUTE 284
#define EXTENSION 285
#define LABEL 286
#define REALPART 287
#define IMAGPART 288
#define ASSIGN 289
#define OROR 290
#define ANDAND 291
#define EQCOMPARE 292
#define ARITHCOMPARE 293
#define LSHIFT 294
#define RSHIFT 295
#define UNARY 296
#define PLUSPLUS 297
#define MINUSMINUS 298
#define HYPERUNARY 299
#define POINTSAT 300
#define INTERFACE 301
#define IMPLEMENTATION 302
#define END 303
#define SELECTOR 304
#define DEFS 305
#define ENCODE 306
#define CLASSNAME 307
#define PUBLIC 308
#define PRIVATE 309
#define PROTECTED 310
#define PROTOCOL 311
#define OBJECTNAME 312
#define CLASS 313
#define ALIAS 314
#define OBJC_STRING 315
#define FORALL 316
#define UPC_BLOCKSIZEOF 317
#define UPC_LOCALSIZEOF 318
#define UPC_ELEMSIZEOF 319
#define UPC_BARRIER 320
#define UPC_NOTIFY 321
#define UPC_WAIT 322
#define END_OF_LINE 323
#define UPC_FENCE 324
const short yylhs[] = {                                        -1,
    0,    0,   83,   81,   84,   81,   82,   82,   82,   82,
   86,   86,   86,   86,   86,   86,   86,   86,   89,   91,
   85,   85,   92,   93,   85,   85,   94,   95,   85,   85,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    3,
    5,    5,    4,    4,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,   78,   79,   80,   96,   97,    7,    7,   99,    7,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,  100,    6,  101,    6,  102,  103,    6,
  104,    6,    6,    6,    9,    9,    9,    9,    9,  105,
    9,    9,    9,    9,    9,    9,    9,   10,   10,   88,
   88,   88,  107,  106,  106,  106,  106,  108,  108,  108,
  108,  110,  112,  112,  112,  112,   70,  113,  111,  111,
  111,  111,  111,  111,  111,   11,   11,   12,   12,   12,
   12,   18,   18,   19,   19,   19,   15,   15,   15,   15,
   20,   20,   20,   20,   58,   58,   13,   13,   77,   14,
   14,   16,   16,   16,   16,   16,   17,   17,   17,   23,
   23,   24,   24,   28,   28,  116,   25,   25,  117,   26,
   26,   33,   33,   34,   34,   35,   36,   36,   37,   37,
   37,   37,   37,   38,   38,   38,   38,   27,  118,   27,
   27,   98,   98,  119,  119,  121,  121,  125,  121,  121,
  126,  123,  123,  123,  122,  122,  124,  124,  124,  127,
  128,  114,  129,  130,  115,   40,   40,   42,   42,   42,
   42,   42,   42,   42,   43,   43,   43,   43,   43,   43,
   43,   41,   41,   41,   41,   41,   41,   41,   41,   52,
   52,   53,   53,   54,   54,  131,   44,   44,   44,  132,
   44,   44,   44,  133,   44,  135,   44,   44,  120,  120,
  134,  134,   45,   45,   46,   46,   46,   47,   47,   47,
   47,   47,   47,   48,   48,   49,   49,   49,   50,   50,
   50,   51,   51,   55,   55,   56,   56,   21,   21,   59,
   59,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,  136,   72,   72,   72,  137,  137,  109,  138,  139,
  139,  140,  140,  141,   90,   90,  142,   39,   39,   39,
   39,  143,  143,  144,  147,  146,   74,   75,  145,  145,
   71,   73,   73,  148,  148,  148,  151,  148,  148,  148,
  152,  153,  148,  148,  148,  154,  155,  156,  148,  157,
  158,  159,  160,  148,  161,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  148,  148,  148,   76,   76,  150,  163,  162,  149,
  149,  149,  149,   22,   22,   60,   60,   60,   29,   29,
   30,   30,   31,   32,   32,  164,   64,   65,  165,   65,
   65,   66,   66,   66,   66,   61,   61,   62,   62,   62,
   62,   62,  166,   67,   68,   68,   63,   63,   69,   69,
   87,
};
const short yylen[] = {                                         2,
    0,    1,    0,    2,    0,    3,    1,    1,    5,    2,
    3,    4,    4,    2,    2,    2,    2,    1,    0,    0,
    7,    4,    0,    0,    7,    4,    0,    0,    6,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    1,    1,    3,    1,    2,    2,    2,    2,    2,
    4,    2,    4,    2,    4,    2,    4,    2,    4,    2,
    2,    1,    1,    1,    1,    1,    1,    4,    0,    7,
    1,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    0,    4,    0,    4,    0,    0,    7,
    0,    5,    3,    3,    1,    1,    1,    3,    3,    0,
    4,    4,    4,    3,    3,    2,    2,    1,    2,    0,
    1,    2,    3,    1,    1,    2,    2,    4,    4,    2,
    2,    3,    1,    1,    2,    2,    0,    0,    4,    4,
    3,    3,    2,    2,    2,    2,    3,    0,    2,    2,
    2,    2,    3,    0,    2,    2,    1,    1,    2,    2,
    1,    1,    2,    2,    1,    2,    2,    3,    3,    0,
    2,    1,    1,    1,    4,    4,    1,    1,    1,    1,
    3,    1,    3,    0,    4,    0,    6,    3,    0,    6,
    3,    0,    1,    1,    2,    6,    1,    3,    0,    1,
    4,    6,    4,    1,    1,    1,    1,    1,    0,    4,
    1,    0,    2,    1,    3,    3,    2,    0,    4,    1,
    0,    4,    1,    1,    1,    2,    2,    5,    3,    0,
    0,    5,    0,    0,    5,    1,    1,    3,    3,    4,
    3,    3,    3,    1,    3,    4,    4,    3,    3,    3,
    1,    3,    3,    3,    4,    4,    3,    3,    1,    1,
    2,    1,    2,    1,    2,    0,    7,    5,    2,    0,
    7,    5,    2,    0,    8,    0,    7,    2,    0,    1,
    0,    1,    1,    2,    0,    3,    2,    3,    1,    3,
    1,    1,    2,    1,    3,    4,    6,    5,    1,    3,
    1,    1,    3,    2,    2,    0,    1,    1,    2,    0,
    2,    3,    3,    2,    3,    4,    3,    2,    3,    2,
    3,    1,    1,    2,    2,    0,    1,    2,    0,    0,
    1,    1,    2,    3,    1,    2,    1,    2,    6,    5,
    5,    2,    2,    4,    0,    4,    0,    0,    3,    4,
    3,    1,    1,    1,    1,    2,    0,    4,    1,    3,
    0,    0,    7,    5,    2,    0,    0,    0,   12,    0,
    0,    0,    0,   15,    0,    6,    2,    2,    2,    3,
    2,    2,    3,    2,    3,    2,    3,    6,    8,   10,
   12,    3,    4,    1,    1,    1,    1,    0,    6,    3,
    5,    2,    3,    0,    1,    0,    1,    1,    0,    1,
    1,    3,    4,    1,    3,    0,    2,    2,    0,    4,
    2,    0,    1,    1,    3,    1,    3,    4,    4,    4,
    4,    4,    0,    2,    1,    2,    1,    3,    1,    3,
    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,  164,  152,  162,    0,    0,
    0,    0,    0,    0,    0,  431,   18,    0,    0,  138,
    0,    0,  184,  163,    0,    0,    0,  151,    0,    4,
    7,    8,    0,    6,   16,   17,    0,  156,    0,    0,
    0,    0,    0,    0,   15,    0,   14,  138,    0,    0,
    0,    0,  154,  153,  185,   31,   32,  275,    0,  275,
    0,  266,    0,  249,  300,    0,    0,  172,    0,    0,
   10,   95,   96,  108,   65,   66,    0,    0,    0,   33,
   35,   34,    0,   36,   37,    0,   62,   63,   64,   38,
   39,    0,  397,    0,    0,   71,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  160,    0,    0,  298,    0,  234,  300,    0,    0,  170,
    0,    0,    0,    0,    0,    0,    0,  140,  167,  168,
  139,    0,  169,    0,    0,  256,    0,  260,    0,  264,
    0,    0,   11,    0,    0,   30,    0,  423,    0,    0,
    0,   60,   61,   49,   46,    0,    0,    0,    0,   48,
    0,    0,    0,    0,   86,   84,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  106,  107,
    0,    0,    0,    0,  109,  159,    0,   52,    0,   54,
    0,   56,   47,    0,   50,    0,   58,    0,  165,  300,
    0,    0,    0,  294,    0,    0,  160,  295,  299,  166,
  195,  196,  197,  194,    0,  187,    0,    0,    0,   13,
    0,    0,   22,    0,    0,  423,    0,   12,   26,    0,
    0,  282,  277,    0,    0,    0,    0,  275,    0,  275,
  291,    0,    0,  289,    0,    0,  301,  243,  173,    0,
    0,    0,  242,    0,    0,  247,    0,    0,    0,    0,
  338,   28,    0,    0,  115,   99,   98,    0,  327,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   74,   75,   76,
  105,  104,    0,    0,    0,    0,    0,    0,    0,    0,
    9,    0,    0,  308,    0,  310,    0,    0,  406,    0,
  161,    0,    0,    0,    0,    0,  228,  171,    0,    0,
   20,  229,  231,    0,   24,  258,  337,  337,  276,  283,
    0,  262,    0,    0,    0,    0,    0,    0,    0,  427,
  413,  127,    0,    0,  416,    0,  425,    0,  424,  245,
  246,  179,  318,    0,    0,  112,  116,  117,   69,   68,
  101,  328,    0,    0,    0,    0,    0,  102,  103,   53,
   55,   57,   51,   59,    0,  302,  407,  309,    0,  305,
  307,    0,  186,  188,    0,    0,  176,    0,  230,    0,
    0,  284,  338,    0,    0,    0,    0,  290,    0,    0,
  175,  411,    0,    0,  409,    0,  426,    0,  408,    0,
  144,    0,    0,  113,    0,  325,   29,    0,    0,    0,
    0,  322,   89,    0,  306,  191,    0,  193,    0,   21,
   25,  337,    0,  257,  261,  267,    0,  241,  300,    0,
    0,    0,    0,    0,  300,    0,    0,    0,    0,  415,
  417,  428,  201,  199,    0,  180,    0,  120,    0,  121,
  144,    0,  326,  214,    0,    0,    0,  211,    0,    0,
    0,    0,  204,    0,  210,    0,  429,    0,    0,  313,
    0,  338,  124,    0,    0,    0,  323,    0,    0,  177,
  285,    0,    0,  265,    0,    0,  419,  423,    0,  418,
  420,    0,    0,  421,  422,  410,    0,  146,  145,    0,
    0,    0,    0,  217,    0,    0,  208,   70,    0,  203,
    0,  216,  207,  324,    0,  330,  314,  338,  315,    0,
  126,  125,  317,    0,  331,    0,  192,    0,    0,  286,
    0,    0,  235,    0,  238,    0,    0,  118,  119,    0,
  219,    0,    0,  205,  206,  430,    0,    0,    0,  351,
  335,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  384,    0,    0,    0,    0,
  344,  341,    0,  122,    0,    0,    0,  342,  343,  345,
  387,  329,  288,    0,  236,  237,  200,    0,  212,  209,
    0,    0,  337,    0,    0,    0,  392,  367,  368,  369,
    0,    0,    0,  395,    0,    0,  376,    0,  371,    0,
  374,    0,  372,    0,  346,  133,    0,  134,    0,  135,
    0,  333,  338,  332,  355,    0,  287,  218,    0,    0,
    0,    0,    0,    0,    0,  390,  370,    0,  382,    0,
    0,  377,  373,  375,  393,    0,    0,  131,    0,    0,
  132,  350,  337,    0,    0,  334,    0,  336,  388,  356,
  365,    0,  383,    0,  360,  129,    0,  130,    0,  348,
  339,  337,    0,  352,  337,    0,  337,  391,    0,    0,
    0,  221,  224,  340,  354,  337,  389,    0,  366,    0,
    0,    0,  401,  378,    0,    0,    0,  353,  357,    0,
    0,    0,    0,  361,  222,  225,    0,    0,    0,  379,
  402,    0,    0,  403,    0,    0,    0,  358,    0,    0,
  380,  362,  337,    0,    0,    0,  359,  381,    0,  386,
  385,    0,  363,  337,  364,
};
const short yydgoto[] = {                                       1,
   92,  469,   93,   94,  294,   95,   96,   97,   98,   99,
  342,   52,  110,  206,  343,   20,  131,  412,  457,   21,
  112,  615,  119,   67,  120,   68,  456,  150,  701,  702,
  703,  730,  258,  259,   23,  215,  216,  217,  416,  250,
  123,  124,  443,   24,  134,  135,  236,  391,  392,  243,
  244,   25,   26,   27,  113,  204,  205,   28,  141,  100,
  344,  345,  346,  304,  347,  348,  253,  349,  478,   29,
  480,  481,  582,  633,  354,  742,   38,  101,  102,  103,
    2,   30,    3,    4,   31,   32,  104,  262,  225,  417,
  388,  230,  390,  151,  355,  105,  106,  471,  418,  278,
  277,  275,  488,  276,  159,  263,  264,  414,  265,  484,
  584,  485,  145,  658,  661,  429,  410,  507,  472,  520,
  473,  474,  475,  476,  553,  516,  677,  706,  679,  707,
  238,  240,  245,  336,  139,  486,  534,  363,  420,  421,
  422,  271,  585,  586,  634,  587,  603,  588,  589,  590,
  663,  602,  696,  686,  717,  733,  691,  722,  736,  744,
  687,  591,  685,  305,  449,  254,
};
const short yysindex[] = {                                      0,
    0,    0, 1520, 1520,  106,    0,    0,    0,  -44, -226,
 -226, -226,   45,   73,  100,    0,    0,  186, 1212,    0,
   87, -226,    0,    0,  -49,  128,  260,    0,  227,    0,
    0,    0, 1520,    0,    0,    0, 3162,    0, -226, -226,
 -226, 3200, 2348,  226,    0,   46,    0,    0,   87, -226,
  227,  792,    0,    0,    0,    0,    0,    0,  164,    0,
  175,    0,  185,    0,    0,  227,  250,    0, -226,  271,
    0,    0,    0,    0,    0,    0, 3200, 3200, -178,    0,
    0,    0, 3200,    0,    0, 2154,    0,    0,    0,    0,
    0, 3200,    0,  298, 2189,    0,    0,  -14,  114,  353,
 3267, 3304, 3341, 3200, 3378, 3467, 3200,  350,  400,   83,
    0,  956,  434,    0, 1020,    0,    0,   46,  499,    0,
 -226, -191,   35,  238,  792,  577,  354,    0,    0,    0,
    0, -226,    0,  328, 1644,    0,  357,    0,  382,    0,
  208,  395,    0,   46,  227,    0,  383,    0, 2459, -226,
  239,    0,    0,    0,    0,  458,  472,  501,  439,    0,
 3200, 3200, 3200,    0,    0,    0, 3200, 3200, 3200, 3200,
 3200, 3200, 3200, 3200, 3200, 3200, 3200, 3200,    0,    0,
 -178, -178, 3200, 3200,    0,    0, 2154,    0, 2154,    0,
 2154,    0,    0, 2154,    0, 2154,    0,  489,    0,    0,
   83, 2496, -226,    0,  419,  880,    0,    0,    0,    0,
    0,    0,    0,    0,  200,    0,  521,  445,  555,    0,
   46,   46,    0, -226,  239,    0, 2533,    0,    0,  239,
 -226,    0,    0,    0, 1201,  508, 2258,    0, -226,    0,
    0,  510,  573,    0,  382,   35,    0,    0,    0,  318,
   35,  415,    0, 2335, 2656,    0,  518,  584, -226,  613,
    0,    0,  421,  239,    0,    0,    0, 2611,    0,  651,
  576, 2189, 2189, 2189, 3200,  656, 3200, 3200,  425,  822,
  850,  135,   25,  979,  979,  905,  905,    0,    0,    0,
    0,    0,  298,  680,  645,  701,  708,  724,  734,  746,
    0,   82,  620,    0, 3008,    0,  704,   83,    0, 2693,
    0,  880,  780, 1020, 3483,  238,    0,    0,  238,  762,
    0,    0,    0,  740,    0,    0,    0,    0,    0,    0,
  736,    0,  745, 3200, -178,  764,  573,    9,  808,    0,
    0,    0, 2228,  711,    0,  211,    0,  841,    0,    0,
    0,    0,    0, 1362,  -20,    0,    0,    0,    0,    0,
    0,    0,  604,  836, 3200,  698,  748,    0,    0,    0,
    0,    0,    0,    0,  419,    0,    0,    0,  419,    0,
    0,  835,    0,    0,  370,  889,    0,  -20,    0,  -20,
  888,    0,    0,  888, -226, -226, 2189,    0, -226,  815,
    0,    0,  111,  409,    0, 1631,    0,  682,    0,  511,
    0,  882,  618,    0,  439,    0,    0, 2385, -178,  703,
  604,    0,    0,  337,    0,    0, 3200,    0,  511,    0,
    0,    0,   13,    0,    0,    0, -226,    0,    0,  409,
 -226,   11,  122, -226,    0, -226,   11, -226, 3008,    0,
    0,    0,    0,    0, 2189,    0,  959,    0,   46,    0,
    0,  227,    0,    0,    0, -178, 3200,    0,  891, 2189,
  829,  916,    0,  693,    0, 2422,    0,  760,  171,    0,
  239,    0,    0,  239,    0,  853,    0, 3200,  560,    0,
    0, 3200,    1,    0,   -4,  111,    0,    0, 2730,    0,
    0,  412,  409,    0,    0,    0, 2385,    0,    0,  767,
  959,  776,   66,    0, 1925, 2385,    0,    0, 2385,    0,
 2422,    0,    0,    0, -178,    0,    0,    0,    0, 1374,
    0,    0,    0,  855,    0,  337,    0, 3570, 3200,    0,
  438,  438,    0, 2767,    0,  868,  860,    0,    0, 3200,
    0,  861, 2422,    0,    0,    0, 1885,    0,  947,    0,
    0,  954,  961, 3200,  941,  945,  946, 2842,   76,  754,
  966, 2893, 2961, 2998,  948,    0,  971,  958,  960, 1689,
    0,    0, 2027,    0,  763,  779,   21,    0,    0,    0,
    0,    0,    0, 3570,    0,    0,    0, 3883,    0,    0,
 3200,  992,    0, 3162, 3200, 3787,    0,    0,    0,    0,
  987, 3200,  989,    0,  998, 3162,    0,  990,    0,  991,
    0,  997,    0, -226,    0,    0,   46,    0,  227,    0,
  805,    0,    0,    0,    0, 3200,    0,    0, 1024, 3200,
  795,  115, 1008, 1041, 3200,    0,    0, 1042,    0, 3200,
 1043,    0,    0,    0,    0,  803,  318,    0,  809,   66,
    0,    0,    0, 1885, 1063,    0, 1064,    0,    0,    0,
    0, 2801,    0,  198,    0,    0,  239,    0,  239,    0,
    0,    0, 1047,    0,    0, 3162,    0,    0,  844, 1053,
 3162,    0,    0,    0,    0,    0,    0, 1060,    0, 1081,
  379, 1083,    0,    0, 1065,  439,  439,    0,    0, 3200,
  844, 1076,  844,    0,    0,    0, 3162, 1096,  406,    0,
    0, 3162, 1097,    0,  415, 1091, 1093,    0,  114,  630,
    0,    0,    0, 1098,  415, 3036,    0,    0,  114,    0,
    0, 1117,    0,    0,    0,
};
const short yyrindex[] = {                                    466,
    0, 1255,   68,   68,    0,    0,    0,    0, 4015,  348,
  358,  405,    0,    0,    0,    0,    0,  495,   68,    0,
 4318, 4530,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,    0,    0,    0, 1067,    0,  418,  437,
  441,    0,    0,    0,    0,    0,    0,    0, 4330, 4569,
    0,  797,    0,    0,    0,    0,    0,    0, 4207,    0,
 4244,    0, 4289,    0,    0,    0,    0,    0,  147, 1619,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  340,    0,    0, 1044,    0,    0,    0,    0,
    0,    0,    0,  747,  380,    0,    0,  719, 3609,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1158,
    0, 1158,    0,    0,  639,    0,    0,    0,    0,    0,
   57, 4358, 4589, 4625, 1124,    0, 4702,    0,    0,    0,
    0, 2296,    0,    0, 1077,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  531,
 1267,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3073,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1166,    0,    0,    0, 1044,    0, 1044,    0,
 1044,    0,    0, 1044,    0, 1044,    0,    0,    0,    0,
  895,    0,  482,    0,   32, 3094,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  766,    0,    0,    0,
    0,    0,    0,  531, 1267,    0,    0,    0,    0, 1267,
 4741,    0,    0,  330,   42, 1084,    0,    0, 4741,    0,
    0,    5, 1087,    0,    0, 4371,    0,    0,    0,  156,
 4398,    0,    0, 1167,    0,    0,    0,  814,  646,    0,
    0,    0, 1796, 1026,    0,    0,    0,    0,    0,    0,
  812,  623, 1335, 1405,    0,    0,    0,    0, 3105, 3825,
 4198, 4144, 4101, 4025, 4062, 3928, 3940,    0,    0,    0,
    0,    0, 1172,    0,    0,    0,    0,    0,    0,    0,
    0, 1180,    0,    0, 1167,    0,    0,    0,    0,    0,
    0, 3838,    0,  639, 1166, 4439,    0,    0, 4476,  837,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1103,    0, 1087,    0,    0,    0,
    0,    0, 1275, 1195,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  913,    0,    0, 1328,  773,    0,    0,    0,
    0,    0,    0,    0,   37,    0,    0,    0,  160,    0,
    0,    0,    0,    0, 3645,    0,    0,    0,    0,    0,
  188,    0,    0,  278, 4741, 4741,   51,    0, 4741,    0,
    0,    0,  559,  559,    0,    0,    0,    0,    0,    0,
    0,  495,  532,    0,    0,    0,    0, 1114,    0, 1448,
  985,    0,    0, 2336,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 4741,    0,    0,  895,
  367,  669,  669,  669,    0,  474,  669,  669, 1167,    0,
    0,    0,    0,    0,  857,    0,  543,    0,    0,    0,
    0,    0,    0,    0, 3750,    0,    0,    0,    0,   89,
    0, 1149,    0,    0,    0,  757,    0,    0,    0,    0,
 1817,    0,    0, 1080, 1285,    0,    0,    0,    0,    0,
    0,    0,  317,    0,  671,    0,    0,    0,    0,    0,
    0,  671,    0,    0,    0,    0, 1114,    0,    0,    0,
  567,    0,  156,    0,    0, 1114,    0,    0, 1150,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3434,    0,  317,    0,    0,
  166,  349,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1209,
    0,    0,    0,    0,    0,    0,    0,    0,  495,   68,
    0,    0,    0,    0, 1551, 1984,    0,    0,    0,    0,
    0,    0,    0,  317,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1229,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1229,    0,    0,    0,    0,
    0,    0,    0, 1718,    0,    0,    0,    0,    0,    0,
 2085,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1393,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 4652,    0,    0, 4672,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1267,    0, 1267,    0,
    0,    0,    0,    0,    0, 1229,    0,    0,  435,    0,
 1229,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  539,    0,    0,    0,    0,    0,    0,    0,    0,
  435,    0,    0,    0,    0,    0, 1248,    0,    0,    0,
    0, 1229,    0,    0,    0,    0,    0,    0,  839,    0,
    0,    0,    0,    0,    0, 1248,    0,    0,  930,    0,
    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,  -23,  -42, -117,  976,  481,  -50, 1230,  692, -234,
    8, 1250,  -71, 1092,   10,   -3, -175,    0,  849,   -2,
   36,    0, -390,  -45,   -1,    0,  871, -102,  600,    0,
  599,    0, -120,  117,  224,    0,  999,    0, -125,  -41,
   -6,  141,  213,  -31,  -12,    0, 1085,  993,  892, 1075,
  994,    0,    0,    0,  788,  -97, -138,    3,  -95,  259,
    0,  920,    0, 1061, -268,    0, -197,    0,    0,  -11,
  869,    0,    0, -132, -279,    0,    0,    0,    0,    0,
    0,  256,    0,    0,    0,    0,    6, -200,    0,  393,
    0,    0,    0,    0,    0,    0,    0, -129,    0,    0,
    0,    0,    0,    0,    0,    0, 1110,    0,   28,  890,
  791,    0,  -86,    0,    0,    0,    0,    0,    0,    0,
  864,    0, -342,  906,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1048,    0,  899,    0,    0,    0,    0,
  967,    0,    0,    0, 1634,    0,    0,  728,  731,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 5009
const short yytable[] = {                                     108,
  109,   59,   61,   63,  122,  126,   46,   51,   33,   33,
   18,   18,   19,   19,  208,   48,   49,  338,  261,  224,
  133,  218,   70,   54,  321,  183,  152,  153,  322,  325,
  311,  182,  155,  270,  222,  440,  377,  439,   33,  111,
   18,  160,   19,  157,  127,  114,   37,  137,  292,  401,
  148,   54,  118,  193,  117,  154,  155,   15,  539,  142,
  636,  178,  303,  234,  223,  293,  176,  174,  510,  175,
  492,  177,  297,   58,  148,  297,  184,  303,   56,   57,
  303,  127,  111,  127,   42,  118,  202,  117,  114,  147,
  297,  214,  261,  133,  293,  303,  128,  261,  128,  127,
  281,  149,  269,  320,  302,  148,  257,  127,  207,  127,
  326,  142,   43,  433,  209,  242,  308,  612,  332,   22,
   22,  201,  201,  200,  200,  149,   39,   40,   41,  292,
  261,  111,  213,  523,  246,   50,  311,  114,  251,   44,
  237,  295,  249,  247,  157,   69,  157,  224,  157,   22,
  440,  157,  439,  157,  183,  669,  149,  291,  292,  307,
  182,  498,  121,  375,   35,  234,  281,   69,  132,  379,
  235,  178,  202,  202,  133,  293,  176,  174,  555,  175,
  506,  177,   69,  111,  324,  111,  128,  111,  128,  114,
  111,  114,  111,  114,  393,  393,  114,  293,  114,  174,
  311,  202,  530,  311,  155,  184,  239,   56,   57,  239,
  600,  246,  499,  213,  174,  251,  174,  360,  311,  318,
  247,  242,  327,  328,  239,  331,  203,  333,  203,  353,
   36,  207,  364,  111,  121,  415,  656,  209,  690,  114,
  313,  132,  237,  314,   45,   55,  278,   66,  557,   65,
   60,  407,   64,  438,  408,  689,    9,   69,  219,   34,
  121,   69,   55,   55,   55,  115,   66,  382,   65,   64,
  116,  185,  235,   55,  434,  435,  635,  226,  436,   15,
  133,  509,  179,  180,   15,  181,  136,  482,   71,  463,
  214,  358,   55,  144,   15,  526,   15,  138,  127,  393,
  543,  303,   64,  116,  247,  444,  448,  140,  143,  489,
  148,  242,  278,  128,  128,  297,  494,  203,  172,  173,
  303,  497,  500,  501,  127,  127,  504,  505,  227,   15,
  403,  404,   56,   57,  121,  509,  280,  121,  121,   48,
   49,  161,    9,  495,   55,   53,  147,    9,  528,  502,
  411,  413,  482,  664,  496,   55,  375,  379,  316,  503,
  182,  149,  319,  375,  379,   15,   15,   64,  438,  127,
   22,  127,  540,  178,  169,  182,  185,  547,  176,  174,
  398,  175,   62,  177,   56,   57,  552,  127,  279,  240,
  198,  493,  240,  148,   15,  477,  442,  447,  398,  164,
  459,  462,  280,  128,  581,   15,  128,  240,  128,  461,
  426,  179,  180,  427,  181,   54,  512,  593,  203,  712,
   43,   22,  252,   43,  203,  133,   55,  171,  172,  173,
  168,  581,  398,  142,  148,  248,  711,   43,   43,  174,
  199,  182,  514,  311,  149,  186,  726,  483,  440,  239,
  445,  440,  231,  445,  279,  513,  546,  128,  309,   50,
  167,  178,  169,  725,   64,    1,  176,  174,    9,  175,
  254,  177,   43,  637,  210,  399,  692,  498,  693,  133,
  250,  239,   55,   64,  118,  149,  117,  578,  246,  251,
  729,   15,  399,  155,  260,  246,  251,  247,  266,  202,
  739,  556,  202,  655,  247,    3,  577,    3,  529,  310,
   15,  531,  267,  128,  578,  128,   56,   57,  168,  441,
  446,  128,   22,  128,    3,  611,  146,  252,  499,  618,
  620,  622,  193,  577,  127,  583,  127,  579,  581,  580,
  255,  268,  221,   91,  261,  613,  261,  301,   80,  121,
   86,  147,  107,   81,  224,   82,  446,  220,  639,  251,
  315,  269,  644,  253,  128,   22,  329,  627,  629,  648,
  334,  127,  128,  127,  182,  121,   48,   49,   69,  400,
  715,  716,  142,  659,  142,  657,  127,  127,  583,  182,
  579,  182,  580,  665,  226,  317,  400,  667,  147,  296,
  537,  142,  296,  161,  254,  254,  143,  674,  143,  229,
  351,  441,  441,  127,  250,  250,  335,  296,  446,  446,
  144,  578,  660,  128,  128,  143,  165,  166,  170,  171,
  172,  173,  240,  454,  147,  228,   90,  241,   56,   57,
  577,  272,  273,  274,  352,  227,   22,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  309,
  376,  252,  252,   44,   55,   64,   44,  718,   64,   55,
  734,  353,    9,  735,  255,  255,  460,   74,  183,  189,
   44,   44,  189,  183,  356,  183,  183,  183,  183,  183,
  183,  361,   15,  251,  251,   15,   50,  253,  253,   22,
  362,   64,  116,  183,  183,    9,  183,  541,  542,  182,
  310,  304,  182,  365,  304,   44,  170,  171,  172,  173,
  368,    3,    3,    3,    3,    3,    3,  182,   15,  304,
  128,    3,    3,    3,  178,  169,  183,  369,  466,  176,
  174,  370,  175,  121,  177,   69,    3,    3,  371,    3,
    3,  127,  127,  521,  406,   45,   45,  366,  367,   45,
   45,   45,   45,   45,  372,   45,  453,   72,  183,  405,
  183,  183,   73,   74,  373,   75,   45,   45,  127,   45,
  430,   45,  431,  467,  178,  169,  374,   40,  127,  176,
  174,  168,  175,   76,  177,   16,  378,   77,   78,  142,
  142,   79,  215,  525,   40,   40,  190,   84,   85,  190,
  221,   45,   45,   85,  397,  127,   85,  215,  524,  144,
  383,  167,  387,  143,  143,  548,  142,   87,   88,   89,
   85,   85,  389,   85,  549,   85,  136,  136,  136,   40,
  136,  168,   45,   45,  319,  424,  221,  215,  402,  319,
  143,  319,  144,  319,  319,  136,  319,  181,  178,  169,
  395,  676,  643,  176,  174,   85,  175,  678,  177,  396,
  319,  167,  181,  158,  651,    6,   53,    8,    9,  404,
  178,  409,  404,   10,   11,   12,  178,  136,  399,  419,
  455,  176,  174,  423,  175,  178,  177,   85,  470,   14,
  198,  183,  183,  183,  183,  183,  183,  183,  183,  455,
  183,  183,  183,  183,  183,  198,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  425,  183,  428,
  183,  432,  183,  183,  319,  406,  183,  319,  452,  437,
  458,  178,  183,  183,  698,  320,  176,  515,  517,  705,
  320,  177,  320,  518,  320,  320,  470,  320,  479,  519,
  596,  183,  183,  183,  183,  183,  183,  183,  536,  183,
  405,  320,  538,  405,  296,  723,  297,  535,  298,  592,
  727,  299,   45,  300,  597,  599,  601,  470,  166,  170,
  171,  172,  173,  604,  741,  201,  470,  200,  607,  470,
  605,  470,   45,  608,  609,  616,  623,   45,   45,   45,
   45,   45,   45,   45,  614,  178,  625,  321,  626,  594,
  176,  174,  321,  175,  321,  177,  321,  321,  624,  321,
  598,  640,  631,  470,  632,  320,   85,  650,  320,  170,
  171,  172,  173,  321,  606,  647,  202,  649,  652,  653,
  128,  129,  130,  136,  136,  654,   85,   10,   11,   12,
  662,   85,   85,   85,  666,  668,  670,  319,  319,  319,
  319,  319,  319,  319,  319,   15,  319,  319,  319,  319,
  319,  671,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  673,  675,  319,  683,  684,  695,  700,  321,  319,  319,
  321,  704,  123,  170,  171,  172,  173,  123,  709,  123,
  710,  123,  123,  714,  123,  672,  713,  319,  319,  319,
  319,  319,  319,  319,  720,  319,  724,  728,  123,  129,
  130,  170,  171,  172,  173,   10,   11,   12,  114,  731,
  406,  732,  406,  406,  406,  406,  738,  743,  406,  396,
  406,  406,  406,  137,  137,  137,  100,  137,  320,  320,
  320,  320,  320,  320,  320,  320,  406,  320,  320,  320,
  320,  320,  137,  320,  320,  320,  320,  320,  320,  320,
  320,  320,  320,  320,  320,  320,  320,  320,  296,  320,
  320,  273,  123,  320,  123,  123,   41,  412,  274,  320,
  320,  271,   42,    6,  137,    8,    9,  508,  129,  130,
  304,   10,   11,   12,   10,   11,   12,  272,  320,  320,
  320,  320,  320,  320,  320,  414,  320,   14,  202,   15,
  321,  321,  321,  321,  321,  321,  321,  321,  394,  321,
  321,  321,  321,  321,    2,  321,  321,  321,  321,  321,
  321,  321,  321,  321,  321,  321,  321,  321,  321,  321,
   47,  321,  321,  269,  270,  321,   56,   57,  211,  212,
  213,  321,  321,  114,  114,  114,  114,  396,  396,  114,
  386,  114,  114,  114,    5,  642,    5,  125,  312,  490,
  321,  321,  321,  321,  321,  321,  321,  114,  321,  511,
  719,  721,  384,    5,  127,  127,  127,  337,  127,  337,
  394,  330,  337,  491,  337,  451,  337,  337,  398,  337,
  188,  190,  192,  127,  195,  197,  123,  123,  123,  123,
  123,  123,  123,  337,  123,  123,  123,  123,  123,  527,
  123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
  123,  123,  123,  123,  123,  127,  123,  123,   87,  380,
  123,   87,  357,  630,  532,   94,  123,  123,   94,  522,
  137,  137,  554,  533,  400,   87,   87,  487,   87,  110,
   87,  681,   94,   94,  682,  123,  123,  123,  123,  123,
  123,  123,    0,  123,    0,    0,   91,  337,    0,  316,
  337,   80,    0,   86,    0,  107,   81,    0,   82,    0,
   87,    0,    0,    0,    0,    0,    0,   94,    0,   45,
   45,    0,  576,    0,   45,   45,   45,   45,    0,   45,
    0,    0,    0,    0,    0,   93,    0,    0,   93,    0,
    0,   45,   87,   45,    0,   45,    0,    0,    6,   94,
    8,    9,   93,   93,    0,    0,   10,   11,   12,    6,
    7,    8,    9,    0,    0,    0,    0,   10,   11,   12,
  337,    0,   14,    0,    0,  337,   45,  337,    0,  337,
  337,    0,  337,   14,    0,   15,  269,   93,    0,   90,
    0,    0,    0,    0,    0,    0,  337,    0,    0,    0,
    5,    5,    5,    5,    5,    5,   45,    0,    0,    0,
    5,    5,    5,    0,  337,  337,  337,  337,    0,   93,
    0,  127,  337,  337,  337,    5,    5,    0,    5,    5,
    0,  337,  337,  337,  337,  337,  337,  337,  337,  337,
  337,  337,  337,  337,    0,  337,  337,  337,  337,  337,
  337,  337,  337,  337,  337,  337,  337,  337,  337,  337,
  337,  337,  337,  337,    0,  337,    0,    0,   17,    0,
    0,  337,  337,  349,    0,    0,    0,    0,  349,    0,
  349,   87,  349,  349,    0,  349,    0,    0,   94,    0,
  337,  337,  337,  337,  337,  337,  337,    0,  337,  349,
    0,   87,    0,    0,    0,    0,   87,   87,   94,    6,
    7,    8,    9,    0,    0,    0,    0,   10,   11,   12,
  465,  558,    7,    8,    9,   73,   74,    0,   75,   10,
   11,   12,  559,   14,  560,  561,  562,  563,  564,  565,
  566,  567,  568,  569,  570,   14,   76,   15,   16,    0,
   77,   78,  174,    0,   79,    0,    0,    0,   93,    0,
   84,   85,    0,  349,    0,  349,  349,  174,    0,  174,
    0,   45,   45,   45,   45,   45,   45,   45,   93,  571,
   87,   88,   89,  572,  573,  574,    0,  575,    0,    0,
    0,    0,  233,    0,  337,  337,  337,  337,  337,  337,
  337,    0,  337,  337,  337,  337,  337,    0,  337,  337,
  337,  337,  337,  337,  337,  337,  337,  337,  337,  337,
  337,  337,  337,    0,  337,  337,    0,    0,  337,    0,
    0,   27,    0,    0,  337,  337,    0,  628,    0,    0,
  182,    0,    0,    0,    0,  182,    0,  182,    0,  182,
  182,    0,  182,  337,  337,  337,  337,  337,  337,  337,
    0,  337,    0,    0,    0,    5,  182,    6,    7,    8,
    9,    0,    0,    0,    0,   10,   11,   12,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   13,   14,    0,   15,   16,    0,  349,  349,  349,    0,
    0,    0,  349,  349,    0,  349,    0,    0,    0,  349,
    0,  349,  349,  349,  349,  349,  349,  349,  349,  349,
  349,  349,    0,  349,    0,  349,    0,  349,  349,    0,
  182,  349,  182,  182,    0,    0,    0,  349,  349,  337,
    0,    0,    0,    0,  337,    0,  337,    0,  337,  337,
    0,  337,    0,    0,    0,    0,  349,  349,  349,  349,
  349,  349,  349,    0,  349,  337,   27,   27,   27,   27,
    0,    0,    0,    0,   27,   27,   27,    0,    6,    7,
    8,    9,    0,    0,  450,    0,   10,   11,   12,  232,
   27,    6,  174,    8,    9,    0,    0,    0,    0,   10,
   11,   12,   14,    0,   15,    0,    0,   91,  111,    0,
    0,    0,   80,    0,   86,   14,  107,   81,   16,   82,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  337,
    0,  312,  337,  576,    0,    0,    6,    7,    8,    9,
    0,    0,    0,    0,   10,   11,   12,    0,    0,    0,
    0,  178,  169,    0,    0,    0,  176,  174,    0,  175,
   14,  177,   15,  182,  182,  182,    0,    0,    0,  182,
  182,    0,  182,    0,    0,  163,  182,  164,  182,  182,
  182,  182,  182,  182,  182,  182,  182,  182,  182,    0,
  182,    0,  182,    0,  182,  182,    0,  269,  182,    0,
   90,    0,    0,    0,  182,  182,  337,  551,  168,    0,
    0,  337,    0,  337,    0,  337,  337,    0,  337,    0,
    0,    0,    0,  182,  182,  182,  182,  182,  182,  182,
    0,  182,  337,    0,    0,    0,    0,    0,  167,    0,
    0,  111,    0,  337,  337,  337,  337,    0,    0,   91,
    0,  337,  337,  337,   80,    0,   86,    0,  107,   81,
    0,   82,    0,  337,  337,    0,    0,  337,  337,  337,
    0,  337,    0,    0,    0,  337,    0,  337,  337,  337,
  337,  337,  337,  337,  337,  337,  337,  337,    0,  337,
    0,  337,    0,  337,  337,    0,  337,  337,    0,  337,
    0,    0,    0,  337,  337,    0,    0,  347,    0,    0,
    0,    0,  347,    0,  347,    0,  347,  347,    0,  347,
    0,    0,  337,  337,  337,  337,  337,  337,  337,    0,
  337,  465,   57,  347,    0,    0,   73,   74,    0,   75,
    0,    0,   90,  559,    0,  560,  561,  562,  563,  564,
  565,  566,  567,  568,  569,  570,    0,   76,    0,   16,
    0,   77,   78,    0,    0,   79,    0,    0,    0,    0,
    0,   84,   85,    0,    0,    0,   91,    0,  550,    0,
    0,   80,    0,   86,    0,  107,   81,    0,   82,    0,
  571,   87,   88,   89,  572,  573,  574,  347,  575,    0,
  347,    0,    0,  162,  165,  166,  170,  171,  172,  173,
    0,    0,    0,    0,    0,  178,  169,    0,    0,    0,
  176,  174,    0,  175,    0,  177,  641,    0,    0,    0,
  337,  337,    0,    0,    0,  337,  337,    0,  337,  163,
    0,  164,  337,    0,  337,  337,  337,  337,  337,  337,
  337,  337,  337,  337,  337,    0,  337,    0,  337,    0,
  337,  337,    0,    0,  337,    0,    0,    0,    0,   90,
  337,  337,  168,   72,    6,    7,    8,    9,   73,   74,
    0,   75,   10,   11,   12,    0,  680,    0,    0,  337,
  337,  337,  337,  337,  337,  337,    0,  337,   14,   76,
   15,   16,  167,   77,   78,  694,    0,   79,  697,    0,
  699,    0,    0,   84,   85,    0,    0,    0,    0,  708,
    0,    0,    0,    0,    0,  141,  141,  141,    0,  141,
    0,  347,  347,   87,   88,   89,  347,  347,    0,  347,
    0,    0,    0,  347,  141,  347,  347,  347,  347,  347,
  347,  347,  347,  347,  347,  347,  737,  347,    0,  347,
    0,  347,  347,    0,    0,  347,   92,  745,    0,   92,
   91,  347,  347,    0,    0,   80,  141,   86,    0,  107,
   81,    0,   82,   92,   92,    0,   92,    0,    0,    0,
  347,  347,  347,  347,  347,  347,  347,    0,  347,  156,
   72,    6,    0,    8,    9,   73,   74,   91,   75,   10,
   11,   12,   80,    0,   86,    0,  107,   81,   92,   82,
  466,    0,    0,    0,    0,   14,   76,    0,   16,    0,
   77,   78,    0,    0,   79,    0,    0,    0,    0,    0,
   84,   85,    0,    0,   91,    0,    0,    0,    0,   80,
   92,   86,    0,  107,   81,    0,   82,    0,    0,    0,
   87,   88,   89,   90,    0,  467,    0,  162,  165,  166,
  170,  171,  172,  173,    0,    6,    7,    8,    9,    0,
    0,   91,    0,   10,   11,   12,   80,    0,   86,    0,
  255,   81,    0,   82,    0,    0,    0,  468,    0,   14,
   90,   15,    0,  232,    0,    6,    0,    8,    9,    0,
    0,    0,    0,   10,   11,   12,    0,    0,   91,    0,
    0,    0,    0,   80,    0,   86,    0,  107,   81,   14,
   82,    0,   16,    0,  468,    0,    0,   90,    0,    0,
    0,  256,  141,  141,  141,  141,  141,    0,    0,    0,
    0,  141,  141,  141,    0,   91,    0,    0,    0,    0,
   80,    0,   86,    0,  107,   81,    0,   82,    0,    0,
    0,    0,    0,    0,   90,    0,    0,    0,  306,    0,
  339,  340,    6,    7,    8,    9,    0,    0,  341,   92,
   10,   11,   12,    0,   72,    6,    0,    8,    9,   73,
   74,    0,   75,   10,   11,   12,   14,    0,   15,   92,
    0,   90,    0,    0,   92,  323,    0,    0,    0,   14,
   76,    0,   16,    0,   77,   78,    0,    0,   79,    0,
  464,  465,   57,   91,   84,   85,   73,   74,   80,   75,
   86,    0,  107,   81,    0,   82,    0,    0,   90,    0,
    0,    0,    0,    0,   87,   88,   89,   76,    0,   16,
    0,   77,   78,    0,    0,   79,    0,  464,   72,    0,
    0,   84,   85,   73,   74,    0,   75,    0,   91,    0,
    0,    0,    0,   80,    0,   86,    0,  107,   81,    0,
   82,   87,   88,   89,   76,    0,   16,    0,   77,   78,
    0,    0,   79,    0,    0,   72,    0,    0,   84,   85,
   73,   74,    0,   75,    0,   91,    0,    0,    0,    0,
   80,    0,   86,  359,  107,   81,   90,   82,   87,   88,
   89,   76,    0,   16,    0,   77,   78,    0,  350,   79,
    0,    0,   72,    0,    0,   84,   85,   73,   74,    0,
   75,    0,   91,    0,    0,    0,    0,   80,    0,   86,
    0,  544,   81,    0,   82,   87,   88,   89,   76,    0,
   16,   90,   77,   78,    0,  381,   79,    0,    0,   72,
    0,    0,   84,   85,   73,   74,    0,   75,    0,   91,
    0,    0,    0,    0,   80,    0,   86,    0,  107,   81,
    0,   82,   87,   88,   89,   76,    0,   16,   90,   77,
   78,    0,  545,   79,    0,    0,    0,    0,    0,   84,
   85,    0,    0,    0,    0,    0,    0,  178,  169,    0,
    0,    0,  176,  174,    0,  175,    0,  177,    0,   87,
   88,   89,    0,    0,    0,   90,    0,    0,  688,  595,
    0,  163,    0,  164,    0,    0,    0,   72,    0,    0,
    0,    0,   73,   74,   91,   75,    0,    0,    0,   80,
    0,   86,    0,  107,   81,    0,   82,    0,    0,    0,
    0,    0,   90,   76,  168,   16,    0,   77,   78,    0,
  610,   79,    0,    0,    0,    0,    0,   84,   85,    0,
    0,    0,   72,    0,    0,    0,    0,   73,   74,    0,
   75,    0,    0,    0,  167,   91,    0,   87,   88,   89,
   80,    0,   86,    0,  107,   81,    0,   82,   76,    0,
   16,    0,   77,   78,    0,    0,   79,    0,    0,   72,
    0,  617,   84,   85,   73,   74,    0,   75,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   90,    0,    0,
    0,    0,   87,   88,   89,   76,    0,   16,    0,   77,
   78,    0,    0,   79,    0,    0,   72,    0,    0,   84,
   85,   73,   74,   91,   75,    0,    0,    0,   80,    0,
   86,    0,  107,   81,    0,   82,    0,    0,    0,   87,
   88,   89,   76,    0,   16,    0,   77,   78,   90,  619,
   79,    0,    0,   72,    0,    0,   84,   85,   73,   74,
   91,   75,    0,    0,    0,   80,    0,   86,    0,  107,
   81,    0,   82,    0,    0,    0,   87,   88,   89,   76,
    0,   16,    0,   77,   78,    0,  621,   79,    0,    0,
    0,    0,    0,   84,   85,    0,    0,    0,   91,    0,
    0,    0,    0,   80,    0,   86,    0,   83,   81,    0,
   82,    0,    0,   87,   88,   89,   90,    0,    0,  162,
  165,  166,  170,  171,  172,  173,    0,    0,   72,    0,
    0,    0,    0,   73,   74,   88,   75,    0,    0,    0,
   88,    0,   88,    0,   88,   88,    0,   88,    0,    0,
    0,    0,    0,   90,   76,    0,   16,    0,   77,   78,
   91,    0,   79,  157,  157,  157,    0,    0,   84,   85,
    0,    0,    0,    0,    0,   82,    0,    0,   82,   72,
    0,  157,  157,    0,   73,   74,    0,   75,   87,   88,
   89,   90,   82,   82,    0,   82,    0,   82,    0,    0,
    0,    0,    0,    0,    0,   76,    0,   16,    0,   77,
   78,    0,    0,   79,  157,    0,    0,    0,    0,   84,
   85,    0,    0,    0,   91,    0,    0,   82,   88,   80,
    0,   86,    0,   83,   81,    0,   82,    0,    0,   87,
   88,   89,    0,    0,    0,    0,    0,   72,  157,    0,
    0,    0,   73,   74,    0,   75,    0,    0,   82,   82,
    0,    0,   91,    0,    0,    0,    0,   80,    0,   86,
    0,  107,   81,   76,   82,   16,    0,   77,   78,    0,
    0,   79,    0,    0,   72,    0,    0,   84,   85,   73,
   74,    0,   75,  339,    0,    6,    7,    8,    9,    0,
    0,  341,    0,   10,   11,   12,    0,   87,   88,   89,
   76,    0,   16,    0,   77,   78,    0,   90,   79,   14,
    0,   15,   72,    0,   84,   85,    0,   73,   74,   91,
   75,    0,    0,    0,   80,    0,  187,    0,  107,   81,
    0,   82,    0,  740,   87,   88,   89,    0,   76,    0,
   16,    0,   77,   78,    0,   90,   79,    0,    0,   88,
    0,    0,   84,   85,   88,   88,   91,   88,    0,    0,
    0,   80,    0,  189,    0,  107,   81,    0,   82,    0,
  157,  157,   87,   88,   89,   88,    0,   88,    0,   88,
   88,    0,    0,   88,    0,    0,    0,    0,   82,   88,
   88,    0,    0,   91,    0,    0,    0,  157,   80,    0,
  191,    0,  107,   81,    0,   82,    0,    0,   82,   88,
   88,   88,   90,   82,   82,   82,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   91,    0,    0,    0,    0,   80,    0,  194,   72,  107,
   81,    0,   82,   73,   74,    0,   75,    0,    0,   90,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   76,    0,   16,    0,   77,   78,
    0,    0,   79,    0,    0,    0,   72,    0,   84,   85,
    0,   73,   74,    0,   75,    0,   90,    0,    0,    0,
    0,    0,    0,    0,   90,    0,    0,   90,   87,   88,
   89,    0,   76,    0,   16,    0,   77,   78,    0,    0,
   79,   90,   90,    0,   90,    0,   84,   85,    0,   91,
    0,    0,    0,   90,   80,    0,  196,    0,  107,   81,
    0,   82,    0,    0,    0,   91,   87,   88,   89,    0,
   80,    0,   86,   72,  107,   81,   90,   82,   73,   74,
    0,   75,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   76,
    0,   16,    0,   77,   78,    0,    0,   79,   90,    0,
   72,    0,    0,   84,   85,   73,   74,    0,   75,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   87,   88,   89,   76,    0,   16,    0,
   77,   78,   90,    0,   79,    0,    0,   72,    0,    0,
   84,   85,   73,   74,    0,   75,  178,  169,   90,    0,
    0,  176,  174,    0,  175,    0,  177,    0,    0,    0,
   87,   88,   89,   76,    0,   16,    0,   77,   78,    0,
  163,   79,  164,    0,   72,    0,    0,   84,   85,   73,
   74,    0,   75,    0,    0,   97,   97,    0,   97,   97,
   97,   97,   97,   97,   97,   97,    0,   87,   88,   89,
   76,    0,   16,  168,   77,   78,   97,   97,   79,   97,
    0,   97,    0,    0,   84,   85,    0,    0,    0,    0,
    0,   95,   95,    0,   95,    0,   95,   95,    0,   95,
   95,   95,    0,  167,   87,   88,   89,   90,    0,   97,
    0,   97,   97,    0,    0,   95,    0,   95,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   90,    0,    0,
    0,    0,   90,   72,    0,    0,    0,    0,   73,   74,
    0,   75,   97,   97,    0,   95,    0,    0,   95,  385,
    0,    0,    0,    0,   73,   74,    0,   75,    0,   76,
    0,   16,    0,   77,   78,    0,    0,   79,    0,    0,
    0,    0,    0,   84,   85,   76,    0,   16,   95,   77,
   78,    0,    0,   79,    0,    0,    0,    0,    0,   84,
   85,    0,    0,   87,   88,   89,   95,   95,    0,   95,
    0,   95,   95,   95,   95,   95,   95,    0,    0,   87,
   88,   89,    0,    0,    0,    0,    0,   31,   95,    0,
   95,    0,   95,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  178,  169,    0,    0,    0,  176,  174,
    0,  175,    0,  177,    0,    0,    0,    0,    0,    0,
   95,    0,    0,   95,  646,    0,    0,  163,    0,  164,
    0,    0,    0,   15,    0,    0,    0,    0,  162,  165,
  166,  170,  171,  172,  173,   83,    0,    0,   83,    0,
    0,    0,   97,   95,   95,    0,    0,  158,  158,  158,
  168,    0,   83,   83,    0,   83,    0,   83,    0,    0,
    0,    0,   97,    0,    0,  158,  158,   97,   97,   97,
   97,   97,   97,   97,    0,   97,   97,    0,   97,    0,
  167,    0,    0,    0,    0,    0,    0,   83,   83,  178,
  169,    0,    0,    0,  176,  174,    0,  175,  158,  177,
    0,    0,    0,   95,   95,   95,   95,   95,   95,   95,
    0,   95,   95,  163,   95,  164,    0,    0,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  158,    0,    0,   72,    0,    0,   72,    0,
   72,   72,   72,    0,    0,  638,  168,   73,    0,    0,
   73,    0,   73,   73,   73,   72,   72,    0,   72,    0,
   72,    0,    0,    0,    0,    0,    0,   73,   73,    0,
   73,    0,   73,    0,    0,    0,  167,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   72,   72,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   73,   73,    0,    0,    0,    0,   95,   95,
   95,   95,   95,   95,   95,    0,   95,   95,    0,   95,
  645,   72,   72,    0,  155,  155,  155,    0,  155,    0,
    0,    0,   77,   73,   73,   77,    0,    0,   77,    0,
    0,    0,  155,  155,    0,  162,  165,  166,  170,  171,
  172,  173,   77,   77,    0,   77,    0,   77,   83,    0,
    0,    0,    0,    0,  158,  158,    0,    0,    0,   78,
    0,    0,   78,    0,    0,   78,    0,    0,   83,    0,
    0,    0,    0,   83,   83,   83,    0,   77,   77,   78,
   78,  158,   78,    0,   78,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   79,  155,
    0,   79,    0,    0,   79,    0,    0,    0,   77,   77,
    0,    0,    0,    0,   78,   78,    0,    0,   79,   79,
    0,   79,    0,   79,    0,    0,    0,    0,    0,    0,
    0,  162,  165,  166,  170,  171,  172,  173,  164,    0,
  164,   80,    0,    0,   80,   78,   78,   80,    0,    0,
    0,   72,    0,   79,   79,    0,   32,  164,    0,    0,
    0,   80,   80,   73,   80,    0,   80,    0,    0,    0,
    0,   72,    0,    0,    0,    0,   72,   72,   72,   72,
   72,   72,   72,   73,   79,   79,    0,    0,   73,   73,
   73,   73,   73,   73,   73,   81,   80,   80,   81,    0,
    0,   81,    0,    0,    0,    0,  259,  259,  259,    0,
  259,    0,    0,    0,    0,   81,   81,    0,   81,    0,
   81,    0,    0,    0,  259,  259,    0,   80,   80,    0,
    0,  155,  155,  155,  155,  155,    0,    0,    0,    0,
  155,  155,  155,  263,  263,  263,    0,  263,   77,    0,
   81,   81,    0,    0,    0,    0,  155,  259,  155,    0,
    0,  263,  263,    0,    0,    0,    0,    0,   77,    0,
    0,    0,    0,   77,   77,   77,   77,   77,   77,   77,
    0,   81,   81,    0,    0,   78,    0,    0,  268,  268,
  268,  259,  268,    0,  263,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   78,  268,  268,    0,    0,
   78,   78,   78,   78,   78,   78,   78,  147,  147,  147,
    0,  147,    0,    0,   79,    0,    0,    0,  263,  149,
  149,  149,    0,  149,    0,    0,  147,    0,    0,  268,
    0,    0,    0,    0,   79,    0,    0,    0,  149,   79,
   79,   79,   79,   79,    0,  164,  164,  164,  164,  164,
    0,  174,    0,    0,  164,  164,  164,   80,  147,    0,
    0,  244,    0,  268,  244,    0,  174,    0,  174,    0,
  149,    0,  164,    0,    0,    0,    0,   80,  244,  244,
    0,  244,   80,   80,   80,   80,    0,    0,  248,    0,
    0,  248,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  248,  248,    0,  248,    0,
    0,   81,    0,  259,  259,  259,  259,  259,    0,    0,
    0,    0,  259,  259,  259,    0,    0,    0,    0,  232,
   19,   81,  232,    0,    0,    0,   81,   81,   81,    0,
  259,    0,    0,  244,    0,  244,  232,  232,    0,  232,
  263,  263,  263,  263,  263,    0,    0,    0,    0,  263,
  263,  263,    0,    0,    0,    0,  233,    0,    0,  233,
  248,    0,  248,    0,    0,    0,    0,  263,    0,    0,
    0,    0,    0,  233,  233,    0,  233,    0,    0,    0,
    0,    0,    0,    0,    0,  268,  268,  268,  268,  268,
    0,    0,    0,    0,  268,  268,  268,    0,    0,    0,
    0,  232,    0,  232,    0,    0,    0,    0,    0,  148,
  148,  148,  268,  148,  147,  147,    0,  147,    0,    0,
    0,    0,    0,  147,  147,  147,  149,  149,  148,  149,
    0,    0,    0,    0,    0,  149,  149,  149,  233,  147,
  233,  147,    0,    0,    0,    0,    0,    0,  150,  150,
  150,  149,  150,  149,    0,   19,   19,   19,   19,    0,
  148,    0,    0,   19,   19,   19,  244,  150,  244,  244,
  244,  244,  227,    0,    0,    0,  244,  244,  244,   19,
    0,  174,    0,    0,    0,    0,  227,  227,    0,  227,
    0,  244,  244,  248,  244,  248,  248,  248,  248,  150,
    0,    0,    0,  248,  248,  248,    0,    0,  226,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  248,  248,
    0,  248,  226,  226,    0,  226,    0,    0,    0,    0,
    0,    0,    0,    0,  232,  174,  232,  232,  232,  232,
    0,    0,    0,    0,  232,  232,  232,    0,    0,    0,
  174,  227,  174,  227,    0,  174,    0,    0,    0,  232,
  232,    0,  232,    0,    0,    0,    0,    0,    0,    0,
  174,  233,  174,  233,  233,  233,  233,    0,    0,    0,
    0,  233,  233,  233,    0,  174,    0,  226,    0,  226,
    0,    0,    0,    0,    0,    0,  233,  233,    0,  233,
  174,    0,  174,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  220,    0,    0,    0,    0,    0,
  182,  182,  182,    0,  182,    0,  148,  148,  148,  148,
  148,    0,    0,    0,  223,  148,  148,  148,  182,  182,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  148,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   23,  150,  150,  150,  150,  150,
    0,  182,    0,    0,  150,  150,  150,    0,    0,    0,
    0,    0,    0,    0,  227,    0,  227,  227,  227,  227,
  150,    0,    0,    0,  227,  227,  227,    0,    0,    0,
    0,    0,    0,    0,    0,  182,    0,    0,    0,  227,
  227,    0,  227,    0,    0,    0,    0,    0,    0,    0,
  226,    0,  226,  226,  226,  226,    0,    0,    0,    0,
  226,  226,  226,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  226,  226,  220,  226,  220,
  220,  220,  220,    0,    0,    0,    0,  220,  220,  220,
    0,    0,    0,    0,    0,    0,    0,  223,    0,  223,
  223,  223,  223,  220,    0,  174,    0,  223,  223,  223,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  223,    0,  174,    0,    0,    0,   23,
   23,   23,   23,    0,    0,    0,    0,   23,   23,   23,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   23,    0,  174,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  182,  182,  182,
  182,  182,    0,    0,    0,    0,  182,  182,  182,
};
const short yycheck[] = {                                      42,
   43,   25,   26,   27,   46,   51,   18,   19,    3,    4,
    3,    4,    3,    4,  112,   19,   19,  252,  151,  122,
   52,  117,   29,   21,  225,   40,   77,   78,  226,  230,
  206,   46,   83,  159,  121,   40,  305,   42,   33,   43,
   33,   92,   33,   86,   51,   43,   91,   60,   44,   41,
   40,   49,   40,  104,   42,   79,  107,  284,   58,   66,
   40,   37,  201,  135,  256,  183,   42,   43,  459,   45,
   58,   47,   41,  123,   40,   44,   91,   41,  257,  258,
   44,   40,   86,   42,   40,   40,   91,   42,   86,  281,
   59,  115,  225,  125,   44,   59,   40,  230,   42,   58,
   59,   91,  123,  224,  200,   40,  149,   40,  112,   42,
  231,  118,   40,  393,  112,  139,  203,   42,  239,    3,
    4,   40,   40,   42,   42,   91,   10,   11,   12,  125,
  263,  135,   44,  476,  141,   19,  312,  135,  145,   40,
  135,  184,  144,  141,  187,   29,  189,  250,  191,   33,
   40,  194,   42,  196,   40,   41,   91,  181,  182,  202,
   46,   40,   46,  302,   59,  237,  125,   51,   52,  308,
  135,   37,   91,   91,  206,  125,   42,   43,  521,   45,
  449,   47,   66,  187,  227,  189,   40,  191,   42,  187,
  194,  189,  196,  191,  327,  328,  194,  315,  196,   44,
   41,   91,  482,   44,  255,   91,   41,  257,  258,   44,
  553,  218,   91,  125,   59,  222,   61,  268,   59,  221,
  218,  245,  234,  235,   59,  238,  110,  240,  112,   59,
  125,  235,  275,  237,  118,  256,  627,  235,   41,  237,
   41,  125,  237,   44,   59,   22,   59,   40,  528,   42,
  123,   41,  257,  258,   44,   58,  261,  141,  118,    4,
  144,  145,   39,   40,   41,   40,   40,  310,   42,  257,
  258,  263,  237,   50,  395,  396,  256,   40,  399,  284,
  312,  457,  297,  298,  284,  300,  123,  420,   33,  415,
  314,  264,   69,   44,  284,  125,  284,  123,  257,  432,
  498,  440,  257,  258,  302,  403,  404,  123,   59,  427,
   40,  335,  125,  257,  258,  284,  437,  201,  294,  295,
  284,  442,  443,  444,  257,  284,  447,  448,   91,  284,
  342,  343,  257,  258,  218,  511,   59,  221,  222,  343,
  343,   44,  261,  439,  121,  259,  281,  261,  481,  445,
  354,  354,  485,  633,  441,  132,  495,  496,  218,  446,
   44,   91,  222,  502,  503,  284,  284,  257,  258,   40,
  254,   42,  493,   37,   38,   59,  263,  507,   42,   43,
   41,   45,  123,   47,  257,  258,  516,   58,   59,   41,
   41,  433,   44,   40,  284,  419,  403,  404,   59,   63,
  412,  413,  125,  257,  530,  284,   40,   59,   42,  413,
   41,  297,  298,   44,  300,  413,  462,  538,  302,   41,
   41,  305,   40,   44,  308,  457,  203,  293,  294,  295,
   94,  557,   93,  440,   40,   41,   58,   58,   59,  284,
   41,  125,  466,  284,   91,   93,   41,  420,   40,  284,
   42,   40,  125,   42,  125,  462,  499,   91,   40,  343,
  124,   37,   38,   58,  257,    0,   42,   43,  261,   45,
  123,   47,   93,  594,   41,   41,  677,   40,  679,  511,
  123,  125,  259,  257,   40,   91,   42,  530,  495,  496,
  725,  284,   58,  544,  256,  502,  503,  495,   41,   91,
  735,  525,   91,  624,  502,   40,  530,   42,  481,   91,
  284,  484,   41,   40,  557,   42,  257,  258,   94,  403,
  404,   40,  406,   42,   59,  568,  256,  123,   91,  572,
  573,  574,  583,  557,   40,  530,   42,  530,  664,  530,
  123,   41,   44,   33,  677,  569,  679,   59,   38,  433,
   40,  281,   42,   43,  657,   45,  440,   59,  601,  123,
   40,  123,  605,  123,   91,  449,   59,  579,  580,  612,
   61,   40,   91,   42,   44,  459,  580,  580,  462,   41,
  706,  707,   40,  629,   42,  627,  257,  258,  583,   59,
  583,   61,  583,  636,   40,   41,   58,  640,  281,   41,
   41,   59,   44,   44,  257,  258,   40,  650,   42,  256,
   93,  495,  496,  284,  257,  258,   44,   59,  502,  503,
   44,  664,  629,  257,  258,   59,  290,  291,  292,  293,
  294,  295,  284,  123,  281,   59,  126,  256,  257,  258,
  664,  161,  162,  163,   61,   91,  530,  167,  168,  169,
  170,  171,  172,  173,  174,  175,  176,  177,  178,   40,
   41,  257,  258,   41,  441,  257,   44,  710,  257,  446,
   41,   59,  261,   44,  257,  258,   59,  263,   33,   41,
   58,   59,   44,   38,  264,   40,   41,   42,   43,   44,
   45,   41,  284,  257,  258,  284,  580,  257,  258,  583,
  125,  257,  258,   58,   59,  261,   61,  495,  496,   41,
   91,   41,   44,   58,   44,   93,  292,  293,  294,  295,
   41,  256,  257,  258,  259,  260,  261,   59,  284,   59,
  257,  266,  267,  268,   37,   38,   91,   93,   46,   42,
   43,   41,   45,  627,   47,  629,  281,  282,   41,  284,
  285,  257,  258,   61,   44,   37,   38,  277,  278,   41,
   42,   43,   44,   45,   41,   47,  256,  257,  123,   59,
  125,  126,  262,  263,   41,  265,   58,   59,  284,   61,
  388,   63,  390,   91,   37,   38,   41,   41,  257,   42,
   43,   94,   45,  283,   47,  285,   93,  287,  288,  257,
  258,  291,   46,   44,   58,   59,   41,  297,  298,   44,
   44,   93,   94,   41,  334,  284,   44,   61,   59,   44,
   41,  124,   61,  257,  258,   59,  284,  317,  318,  319,
   58,   59,   93,   61,   59,   63,   40,   41,   42,   93,
   44,   94,  124,  125,   33,  365,   44,   91,   41,   38,
  284,   40,   44,   42,   43,   59,   45,   44,   37,   38,
  125,   59,  604,   42,   43,   93,   45,   59,   47,  125,
   59,  124,   59,   86,  616,  258,  259,  260,  261,   41,
   44,   41,   44,  266,  267,  268,   37,   91,  125,  286,
  410,   42,   43,   58,   45,   59,   47,  125,  418,  282,
   44,  256,  257,  258,  259,  260,  261,  262,  263,  429,
  265,  266,  267,  268,  269,   59,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,   93,  283,   41,
  285,   44,  287,  288,  123,   41,  291,  126,  257,  125,
   59,   37,  297,  298,  686,   33,   42,  467,   58,  691,
   38,   47,   40,  125,   42,   43,  476,   45,  256,   44,
   93,  316,  317,  318,  319,  320,  321,  322,  488,  324,
   41,   59,  492,   44,  187,  717,  189,  125,  191,  125,
  722,  194,  264,  196,  125,  125,   40,  507,  291,  292,
  293,  294,  295,   40,  736,   40,  516,   42,   58,  519,
   40,  521,  284,   59,   59,   40,   59,  289,  290,  291,
  292,  293,  294,  295,  261,   37,   59,   33,   59,  539,
   42,   43,   38,   45,   40,   47,   42,   43,   58,   45,
  550,   40,  270,  553,  256,  123,  264,   40,  126,  292,
  293,  294,  295,   59,  564,   59,   91,   59,   59,   59,
  259,  260,  261,  257,  258,   59,  284,  266,  267,  268,
  256,  289,  290,  291,   41,  271,   59,  256,  257,  258,
  259,  260,  261,  262,  263,  284,  265,  266,  267,  268,
  269,   41,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   59,   59,  291,   41,   41,   59,  263,  123,  297,  298,
  126,   59,   33,  292,  293,  294,  295,   38,   59,   40,
   40,   42,   43,   59,   45,  645,   44,  316,  317,  318,
  319,  320,  321,  322,   59,  324,   41,   41,   59,  260,
  261,  292,  293,  294,  295,  266,  267,  268,  123,   59,
  256,   59,  258,  259,  260,  261,   59,   41,  264,   93,
  266,  267,  268,   40,   41,   42,  123,   44,  256,  257,
  258,  259,  260,  261,  262,  263,  282,  265,  266,  267,
  268,  269,   59,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,   41,  287,
  288,  125,  123,  291,  125,  126,   41,   41,  125,  297,
  298,  125,   41,  258,   91,  260,  261,  259,  260,  261,
   41,  266,  267,  268,  266,  267,  268,  125,  316,  317,
  318,  319,  320,  321,  322,   41,  324,  282,  125,  284,
  256,  257,  258,  259,  260,  261,  262,  263,   40,  265,
  266,  267,  268,  269,    0,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
   59,  287,  288,  125,  125,  291,  257,  258,  259,  260,
  261,  297,  298,  258,  259,  260,  261,   59,   41,  264,
  315,  266,  267,  268,   40,  604,   42,   48,  207,  429,
  316,  317,  318,  319,  320,  321,  322,  282,  324,  461,
  711,  713,  314,   59,   40,   41,   42,   33,   44,  245,
  328,  237,   38,  432,   40,  406,   42,   43,  335,   45,
  101,  102,  103,   59,  105,  106,  257,  258,  259,  260,
  261,  262,  263,   59,  265,  266,  267,  268,  269,  481,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,   91,  287,  288,   41,  309,
  291,   44,  263,  583,  485,   41,  297,  298,   44,  474,
  257,  258,  519,  485,  337,   58,   59,  421,   61,  123,
   63,  664,   58,   59,  664,  316,  317,  318,  319,  320,
  321,  322,   -1,  324,   -1,   -1,   33,  123,   -1,  125,
  126,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   37,
   38,   -1,   59,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   59,  125,   61,   -1,   63,   -1,   -1,  258,  125,
  260,  261,   58,   59,   -1,   -1,  266,  267,  268,  258,
  259,  260,  261,   -1,   -1,   -1,   -1,  266,  267,  268,
   33,   -1,  282,   -1,   -1,   38,   94,   40,   -1,   42,
   43,   -1,   45,  282,   -1,  284,  123,   93,   -1,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
  256,  257,  258,  259,  260,  261,  124,   -1,   -1,   -1,
  266,  267,  268,   -1,  258,  259,  260,  261,   -1,  125,
   -1,  257,  266,  267,  268,  281,  282,   -1,  284,  285,
   -1,  257,  258,  259,  260,  261,  262,  263,  282,  265,
  266,  267,  268,  269,   -1,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  123,  287,  288,  126,   -1,  291,   -1,   -1,   59,   -1,
   -1,  297,  298,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,  264,   42,   43,   -1,   45,   -1,   -1,  264,   -1,
  316,  317,  318,  319,  320,  321,  322,   -1,  324,   59,
   -1,  284,   -1,   -1,   -1,   -1,  289,  290,  284,  258,
  259,  260,  261,   -1,   -1,   -1,   -1,  266,  267,  268,
  257,  258,  259,  260,  261,  262,  263,   -1,  265,  266,
  267,  268,  269,  282,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,   -1,
  287,  288,   44,   -1,  291,   -1,   -1,   -1,  264,   -1,
  297,  298,   -1,  123,   -1,  125,  126,   59,   -1,   61,
   -1,  289,  290,  291,  292,  293,  294,  295,  284,  316,
  317,  318,  319,  320,  321,  322,   -1,  324,   -1,   -1,
   -1,   -1,   59,   -1,  257,  258,  259,  260,  261,  262,
  263,   -1,  265,  266,  267,  268,  269,   -1,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,   -1,  287,  288,   -1,   -1,  291,   -1,
   -1,  123,   -1,   -1,  297,  298,   -1,   59,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,  316,  317,  318,  319,  320,  321,  322,
   -1,  324,   -1,   -1,   -1,  256,   59,  258,  259,  260,
  261,   -1,   -1,   -1,   -1,  266,  267,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,  284,  285,   -1,  256,  257,  258,   -1,
   -1,   -1,  262,  263,   -1,  265,   -1,   -1,   -1,  269,
   -1,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,   -1,  283,   -1,  285,   -1,  287,  288,   -1,
  123,  291,  125,  126,   -1,   -1,   -1,  297,  298,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,  316,  317,  318,  319,
  320,  321,  322,   -1,  324,   59,  258,  259,  260,  261,
   -1,   -1,   -1,   -1,  266,  267,  268,   -1,  258,  259,
  260,  261,   -1,   -1,  264,   -1,  266,  267,  268,  256,
  282,  258,  284,  260,  261,   -1,   -1,   -1,   -1,  266,
  267,  268,  282,   -1,  284,   -1,   -1,   33,  123,   -1,
   -1,   -1,   38,   -1,   40,  282,   42,   43,  285,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
   -1,  125,  126,   59,   -1,   -1,  258,  259,  260,  261,
   -1,   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
  282,   47,  284,  256,  257,  258,   -1,   -1,   -1,  262,
  263,   -1,  265,   -1,   -1,   61,  269,   63,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,   -1,
  283,   -1,  285,   -1,  287,  288,   -1,  123,  291,   -1,
  126,   -1,   -1,   -1,  297,  298,   33,   93,   94,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,  322,
   -1,  324,   59,   -1,   -1,   -1,   -1,   -1,  124,   -1,
   -1,  256,   -1,  258,  259,  260,  261,   -1,   -1,   33,
   -1,  266,  267,  268,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,  257,  258,   -1,   -1,  282,  262,  263,
   -1,  265,   -1,   -1,   -1,  269,   -1,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,   -1,  283,
   -1,  285,   -1,  287,  288,   -1,  123,  291,   -1,  126,
   -1,   -1,   -1,  297,  298,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  257,  258,   59,   -1,   -1,  262,  263,   -1,  265,
   -1,   -1,  126,  269,   -1,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,   -1,  283,   -1,  285,
   -1,  287,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,  297,  298,   -1,   -1,   -1,   33,   -1,  264,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
  316,  317,  318,  319,  320,  321,  322,  123,  324,   -1,
  126,   -1,   -1,  289,  290,  291,  292,  293,  294,  295,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,  603,   -1,   -1,   -1,
  257,  258,   -1,   -1,   -1,  262,  263,   -1,  265,   61,
   -1,   63,  269,   -1,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,   -1,  283,   -1,  285,   -1,
  287,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,  126,
  297,  298,   94,  257,  258,  259,  260,  261,  262,  263,
   -1,  265,  266,  267,  268,   -1,  663,   -1,   -1,  316,
  317,  318,  319,  320,  321,  322,   -1,  324,  282,  283,
  284,  285,  124,  287,  288,  682,   -1,  291,  685,   -1,
  687,   -1,   -1,  297,  298,   -1,   -1,   -1,   -1,  696,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   -1,   44,
   -1,  257,  258,  317,  318,  319,  262,  263,   -1,  265,
   -1,   -1,   -1,  269,   59,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  733,  283,   -1,  285,
   -1,  287,  288,   -1,   -1,  291,   41,  744,   -1,   44,
   33,  297,  298,   -1,   -1,   38,   91,   40,   -1,   42,
   43,   -1,   45,   58,   59,   -1,   61,   -1,   -1,   -1,
  316,  317,  318,  319,  320,  321,  322,   -1,  324,  256,
  257,  258,   -1,  260,  261,  262,  263,   33,  265,  266,
  267,  268,   38,   -1,   40,   -1,   42,   43,   93,   45,
   46,   -1,   -1,   -1,   -1,  282,  283,   -1,  285,   -1,
  287,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
  297,  298,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,
  125,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
  317,  318,  319,  126,   -1,   91,   -1,  289,  290,  291,
  292,  293,  294,  295,   -1,  258,  259,  260,  261,   -1,
   -1,   33,   -1,  266,  267,  268,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,  123,   -1,  282,
  126,  284,   -1,  256,   -1,  258,   -1,  260,  261,   -1,
   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,  282,
   45,   -1,  285,   -1,  123,   -1,   -1,  126,   -1,   -1,
   -1,   93,  257,  258,  259,  260,  261,   -1,   -1,   -1,
   -1,  266,  267,  268,   -1,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,   -1,   -1,   93,   -1,
  256,  257,  258,  259,  260,  261,   -1,   -1,  264,  264,
  266,  267,  268,   -1,  257,  258,   -1,  260,  261,  262,
  263,   -1,  265,  266,  267,  268,  282,   -1,  284,  284,
   -1,  126,   -1,   -1,  289,   93,   -1,   -1,   -1,  282,
  283,   -1,  285,   -1,  287,  288,   -1,   -1,  291,   -1,
  256,  257,  258,   33,  297,  298,  262,  263,   38,  265,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,  317,  318,  319,  283,   -1,  285,
   -1,  287,  288,   -1,   -1,  291,   -1,  256,  257,   -1,
   -1,  297,  298,  262,  263,   -1,  265,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,  317,  318,  319,  283,   -1,  285,   -1,  287,  288,
   -1,   -1,  291,   -1,   -1,  257,   -1,   -1,  297,  298,
  262,  263,   -1,  265,   -1,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,  123,   42,   43,  126,   45,  317,  318,
  319,  283,   -1,  285,   -1,  287,  288,   -1,   93,  291,
   -1,   -1,  257,   -1,   -1,  297,  298,  262,  263,   -1,
  265,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,  317,  318,  319,  283,   -1,
  285,  126,  287,  288,   -1,   93,  291,   -1,   -1,  257,
   -1,   -1,  297,  298,  262,  263,   -1,  265,   -1,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  317,  318,  319,  283,   -1,  285,  126,  287,
  288,   -1,   93,  291,   -1,   -1,   -1,   -1,   -1,  297,
  298,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,  317,
  318,  319,   -1,   -1,   -1,  126,   -1,   -1,   58,   93,
   -1,   61,   -1,   63,   -1,   -1,   -1,  257,   -1,   -1,
   -1,   -1,  262,  263,   33,  265,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,  126,  283,   94,  285,   -1,  287,  288,   -1,
   59,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,
   -1,   -1,  257,   -1,   -1,   -1,   -1,  262,  263,   -1,
  265,   -1,   -1,   -1,  124,   33,   -1,  317,  318,  319,
   38,   -1,   40,   -1,   42,   43,   -1,   45,  283,   -1,
  285,   -1,  287,  288,   -1,   -1,  291,   -1,   -1,  257,
   -1,   59,  297,  298,  262,  263,   -1,  265,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
   -1,   -1,  317,  318,  319,  283,   -1,  285,   -1,  287,
  288,   -1,   -1,  291,   -1,   -1,  257,   -1,   -1,  297,
  298,  262,  263,   33,  265,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,  317,
  318,  319,  283,   -1,  285,   -1,  287,  288,  126,   59,
  291,   -1,   -1,  257,   -1,   -1,  297,  298,  262,  263,
   33,  265,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,  317,  318,  319,  283,
   -1,  285,   -1,  287,  288,   -1,   59,  291,   -1,   -1,
   -1,   -1,   -1,  297,  298,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,  317,  318,  319,  126,   -1,   -1,  289,
  290,  291,  292,  293,  294,  295,   -1,   -1,  257,   -1,
   -1,   -1,   -1,  262,  263,   33,  265,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,  126,  283,   -1,  285,   -1,  287,  288,
   58,   -1,  291,   40,   41,   42,   -1,   -1,  297,  298,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  257,
   -1,   58,   59,   -1,  262,  263,   -1,  265,  317,  318,
  319,  126,   58,   59,   -1,   61,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  283,   -1,  285,   -1,  287,
  288,   -1,   -1,  291,   91,   -1,   -1,   -1,   -1,  297,
  298,   -1,   -1,   -1,   33,   -1,   -1,   93,  126,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,  317,
  318,  319,   -1,   -1,   -1,   -1,   -1,  257,  125,   -1,
   -1,   -1,  262,  263,   -1,  265,   -1,   -1,  124,  125,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,  283,   45,  285,   -1,  287,  288,   -1,
   -1,  291,   -1,   -1,  257,   -1,   -1,  297,  298,  262,
  263,   -1,  265,  256,   -1,  258,  259,  260,  261,   -1,
   -1,  264,   -1,  266,  267,  268,   -1,  317,  318,  319,
  283,   -1,  285,   -1,  287,  288,   -1,  126,  291,  282,
   -1,  284,  257,   -1,  297,  298,   -1,  262,  263,   33,
  265,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,  278,  317,  318,  319,   -1,  283,   -1,
  285,   -1,  287,  288,   -1,  126,  291,   -1,   -1,  257,
   -1,   -1,  297,  298,  262,  263,   33,  265,   -1,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
  257,  258,  317,  318,  319,  283,   -1,  285,   -1,  287,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,  264,  297,
  298,   -1,   -1,   33,   -1,   -1,   -1,  284,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,  284,  317,
  318,  319,  126,  289,  290,  291,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,  257,   42,
   43,   -1,   45,  262,  263,   -1,  265,   -1,   -1,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  283,   -1,  285,   -1,  287,  288,
   -1,   -1,  291,   -1,   -1,   -1,  257,   -1,  297,  298,
   -1,  262,  263,   -1,  265,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  317,  318,
  319,   -1,  283,   -1,  285,   -1,  287,  288,   -1,   -1,
  291,   58,   59,   -1,   61,   -1,  297,  298,   -1,   33,
   -1,   -1,   -1,  126,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   33,  317,  318,  319,   -1,
   38,   -1,   40,  257,   42,   43,   93,   45,  262,  263,
   -1,  265,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,
   -1,  285,   -1,  287,  288,   -1,   -1,  291,  125,   -1,
  257,   -1,   -1,  297,  298,  262,  263,   -1,  265,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  317,  318,  319,  283,   -1,  285,   -1,
  287,  288,  126,   -1,  291,   -1,   -1,  257,   -1,   -1,
  297,  298,  262,  263,   -1,  265,   37,   38,  126,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
  317,  318,  319,  283,   -1,  285,   -1,  287,  288,   -1,
   61,  291,   63,   -1,  257,   -1,   -1,  297,  298,  262,
  263,   -1,  265,   -1,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,  317,  318,  319,
  283,   -1,  285,   94,  287,  288,   58,   59,  291,   61,
   -1,   63,   -1,   -1,  297,  298,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   46,   47,   -1,  124,  317,  318,  319,  264,   -1,   91,
   -1,   93,   94,   -1,   -1,   61,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   -1,   -1,  289,  257,   -1,   -1,   -1,   -1,  262,  263,
   -1,  265,  124,  125,   -1,   91,   -1,   -1,   94,  257,
   -1,   -1,   -1,   -1,  262,  263,   -1,  265,   -1,  283,
   -1,  285,   -1,  287,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,  297,  298,  283,   -1,  285,  124,  287,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,
  298,   -1,   -1,  317,  318,  319,   37,   38,   -1,   40,
   -1,   42,   43,   44,   45,   46,   47,   -1,   -1,  317,
  318,  319,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,
   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   94,   58,   -1,   -1,   61,   -1,   63,
   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,  289,  290,
  291,  292,  293,  294,  295,   41,   -1,   -1,   44,   -1,
   -1,   -1,  264,  124,  125,   -1,   -1,   40,   41,   42,
   94,   -1,   58,   59,   -1,   61,   -1,   63,   -1,   -1,
   -1,   -1,  284,   -1,   -1,   58,   59,  289,  290,  291,
  292,  293,  294,  295,   -1,  297,  298,   -1,  300,   -1,
  124,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,   37,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   91,   47,
   -1,   -1,   -1,  289,  290,  291,  292,  293,  294,  295,
   -1,  297,  298,   61,  300,   63,   -1,   -1,  124,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   38,   -1,   -1,   41,   -1,
   43,   44,   45,   -1,   -1,   93,   94,   38,   -1,   -1,
   41,   -1,   43,   44,   45,   58,   59,   -1,   61,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,
   61,   -1,   63,   -1,   -1,   -1,  124,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,  289,  290,
  291,  292,  293,  294,  295,   -1,  297,  298,   -1,  300,
  264,  124,  125,   -1,   40,   41,   42,   -1,   44,   -1,
   -1,   -1,   38,  124,  125,   41,   -1,   -1,   44,   -1,
   -1,   -1,   58,   59,   -1,  289,  290,  291,  292,  293,
  294,  295,   58,   59,   -1,   61,   -1,   63,  264,   -1,
   -1,   -1,   -1,   -1,  257,  258,   -1,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,  284,   -1,
   -1,   -1,   -1,  289,  290,  291,   -1,   93,   94,   58,
   59,  284,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,  125,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  124,  125,
   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  289,  290,  291,  292,  293,  294,  295,   40,   -1,
   42,   38,   -1,   -1,   41,  124,  125,   44,   -1,   -1,
   -1,  264,   -1,   93,   94,   -1,   58,   59,   -1,   -1,
   -1,   58,   59,  264,   61,   -1,   63,   -1,   -1,   -1,
   -1,  284,   -1,   -1,   -1,   -1,  289,  290,  291,  292,
  293,  294,  295,  284,  124,  125,   -1,   -1,  289,  290,
  291,  292,  293,  294,  295,   38,   93,   94,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   40,   41,   42,   -1,
   44,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,   -1,
   63,   -1,   -1,   -1,   58,   59,   -1,  124,  125,   -1,
   -1,  257,  258,  259,  260,  261,   -1,   -1,   -1,   -1,
  266,  267,  268,   40,   41,   42,   -1,   44,  264,   -1,
   93,   94,   -1,   -1,   -1,   -1,  282,   91,  284,   -1,
   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,  284,   -1,
   -1,   -1,   -1,  289,  290,  291,  292,  293,  294,  295,
   -1,  124,  125,   -1,   -1,  264,   -1,   -1,   40,   41,
   42,  125,   44,   -1,   91,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   58,   59,   -1,   -1,
  289,  290,  291,  292,  293,  294,  295,   40,   41,   42,
   -1,   44,   -1,   -1,  264,   -1,   -1,   -1,  125,   40,
   41,   42,   -1,   44,   -1,   -1,   59,   -1,   -1,   91,
   -1,   -1,   -1,   -1,  284,   -1,   -1,   -1,   59,  289,
  290,  291,  292,  293,   -1,  257,  258,  259,  260,  261,
   -1,   44,   -1,   -1,  266,  267,  268,  264,   91,   -1,
   -1,   41,   -1,  125,   44,   -1,   59,   -1,   61,   -1,
   91,   -1,  284,   -1,   -1,   -1,   -1,  284,   58,   59,
   -1,   61,  289,  290,  291,  292,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,   -1,
   -1,  264,   -1,  257,  258,  259,  260,  261,   -1,   -1,
   -1,   -1,  266,  267,  268,   -1,   -1,   -1,   -1,   41,
  123,  284,   44,   -1,   -1,   -1,  289,  290,  291,   -1,
  284,   -1,   -1,  123,   -1,  125,   58,   59,   -1,   61,
  257,  258,  259,  260,  261,   -1,   -1,   -1,   -1,  266,
  267,  268,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
  123,   -1,  125,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
   -1,   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   -1,
   -1,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,  284,   44,  257,  258,   -1,  260,   -1,   -1,
   -1,   -1,   -1,  266,  267,  268,  257,  258,   59,  260,
   -1,   -1,   -1,   -1,   -1,  266,  267,  268,  123,  282,
  125,  284,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,  282,   44,  284,   -1,  258,  259,  260,  261,   -1,
   91,   -1,   -1,  266,  267,  268,  256,   59,  258,  259,
  260,  261,   44,   -1,   -1,   -1,  266,  267,  268,  282,
   -1,  284,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,
   -1,  281,  282,  256,  284,  258,  259,  260,  261,   91,
   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,  284,   58,   59,   -1,   61,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   44,  258,  259,  260,  261,
   -1,   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   -1,
   59,  123,   61,  125,   -1,   44,   -1,   -1,   -1,  281,
  282,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,  256,   61,  258,  259,  260,  261,   -1,   -1,   -1,
   -1,  266,  267,  268,   -1,   44,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,  284,
   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   -1,   44,   -1,  257,  258,  259,  260,
  261,   -1,   -1,   -1,  123,  266,  267,  268,   58,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  257,  258,  259,  260,  261,
   -1,   91,   -1,   -1,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   -1,  258,  259,  260,  261,
  282,   -1,   -1,   -1,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,  281,
  282,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,  258,  259,  260,  261,   -1,   -1,   -1,   -1,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,  256,  284,  258,
  259,  260,  261,   -1,   -1,   -1,   -1,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,  258,
  259,  260,  261,  282,   -1,  284,   -1,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  282,   -1,  284,   -1,   -1,   -1,  258,
  259,  260,  261,   -1,   -1,   -1,   -1,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  282,   -1,  284,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,   -1,   -1,   -1,   -1,  266,  267,  268,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 324
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'",0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","TYPENAME",
"SCSPEC","TYPESPEC","TYPE_QUAL","CONSTANT","STRING","ELLIPSIS","SIZEOF","ENUM",
"STRUCT","UNION","IF","ELSE","WHILE","DO","FOR","SWITCH","CASE","DEFAULT",
"BREAK","CONTINUE","RETURN","GOTO","ASM_KEYWORD","TYPEOF","ALIGNOF","ATTRIBUTE",
"EXTENSION","LABEL","REALPART","IMAGPART","ASSIGN","OROR","ANDAND","EQCOMPARE",
"ARITHCOMPARE","LSHIFT","RSHIFT","UNARY","PLUSPLUS","MINUSMINUS","HYPERUNARY",
"POINTSAT","INTERFACE","IMPLEMENTATION","END","SELECTOR","DEFS","ENCODE",
"CLASSNAME","PUBLIC","PRIVATE","PROTECTED","PROTOCOL","OBJECTNAME","CLASS",
"ALIAS","OBJC_STRING","FORALL","UPC_BLOCKSIZEOF","UPC_LOCALSIZEOF",
"UPC_ELEMSIZEOF","UPC_BARRIER","UPC_NOTIFY","UPC_WAIT","END_OF_LINE",
"UPC_FENCE",
};
const char * const yyrule[] = {
"$accept : program",
"program :",
"program : extdefs",
"$$1 :",
"extdefs : $$1 extdef",
"$$2 :",
"extdefs : extdefs $$2 extdef",
"extdef : fndef",
"extdef : datadef",
"extdef : ASM_KEYWORD '(' expr ')' ';'",
"extdef : extension extdef",
"datadef : setspecs notype_initdecls ';'",
"datadef : declmods setspecs notype_initdecls ';'",
"datadef : typed_declspecs setspecs initdecls ';'",
"datadef : declmods ';'",
"datadef : typed_declspecs ';'",
"datadef : error ';'",
"datadef : error '}'",
"datadef : ';'",
"$$3 :",
"$$4 :",
"fndef : typed_declspecs setspecs declarator $$3 old_style_parm_decls $$4 compstmt_or_error",
"fndef : typed_declspecs setspecs declarator error",
"$$5 :",
"$$6 :",
"fndef : declmods setspecs notype_declarator $$5 old_style_parm_decls $$6 compstmt_or_error",
"fndef : declmods setspecs notype_declarator error",
"$$7 :",
"$$8 :",
"fndef : setspecs notype_declarator $$7 old_style_parm_decls $$8 compstmt_or_error",
"fndef : setspecs notype_declarator error",
"identifier : IDENTIFIER",
"identifier : TYPENAME",
"unop : '&'",
"unop : '-'",
"unop : '+'",
"unop : PLUSPLUS",
"unop : MINUSMINUS",
"unop : '~'",
"unop : '!'",
"expr : nonnull_exprlist",
"exprlist :",
"exprlist : nonnull_exprlist",
"nonnull_exprlist : expr_no_commas",
"nonnull_exprlist : nonnull_exprlist ',' expr_no_commas",
"unary_expr : primary",
"unary_expr : '*' cast_expr",
"unary_expr : extension cast_expr",
"unary_expr : unop cast_expr",
"unary_expr : ANDAND identifier",
"unary_expr : sizeof unary_expr",
"unary_expr : sizeof '(' typename ')'",
"unary_expr : upc_blocksizeof unary_expr",
"unary_expr : upc_blocksizeof '(' typename ')'",
"unary_expr : upc_localsizeof unary_expr",
"unary_expr : upc_localsizeof '(' typename ')'",
"unary_expr : upc_elemsizeof unary_expr",
"unary_expr : upc_elemsizeof '(' typename ')'",
"unary_expr : alignof unary_expr",
"unary_expr : alignof '(' typename ')'",
"unary_expr : REALPART cast_expr",
"unary_expr : IMAGPART cast_expr",
"upc_blocksizeof : UPC_BLOCKSIZEOF",
"upc_localsizeof : UPC_LOCALSIZEOF",
"upc_elemsizeof : UPC_ELEMSIZEOF",
"sizeof : SIZEOF",
"alignof : ALIGNOF",
"cast_expr : unary_expr",
"cast_expr : '(' typename ')' cast_expr",
"$$9 :",
"cast_expr : '(' typename ')' '{' $$9 initlist_maybe_comma '}'",
"expr_no_commas : cast_expr",
"expr_no_commas : expr_no_commas '+' expr_no_commas",
"expr_no_commas : expr_no_commas '-' expr_no_commas",
"expr_no_commas : expr_no_commas '*' expr_no_commas",
"expr_no_commas : expr_no_commas '/' expr_no_commas",
"expr_no_commas : expr_no_commas '%' expr_no_commas",
"expr_no_commas : expr_no_commas LSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas RSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas ARITHCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas EQCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas '&' expr_no_commas",
"expr_no_commas : expr_no_commas '|' expr_no_commas",
"expr_no_commas : expr_no_commas '^' expr_no_commas",
"$$10 :",
"expr_no_commas : expr_no_commas ANDAND $$10 expr_no_commas",
"$$11 :",
"expr_no_commas : expr_no_commas OROR $$11 expr_no_commas",
"$$12 :",
"$$13 :",
"expr_no_commas : expr_no_commas '?' $$12 expr ':' $$13 expr_no_commas",
"$$14 :",
"expr_no_commas : expr_no_commas '?' $$14 ':' expr_no_commas",
"expr_no_commas : expr_no_commas '=' expr_no_commas",
"expr_no_commas : expr_no_commas ASSIGN expr_no_commas",
"primary : IDENTIFIER",
"primary : CONSTANT",
"primary : string",
"primary : '(' expr ')'",
"primary : '(' error ')'",
"$$15 :",
"primary : '(' $$15 compstmt ')'",
"primary : primary '(' exprlist ')'",
"primary : primary '[' expr ']'",
"primary : primary '.' identifier",
"primary : primary POINTSAT identifier",
"primary : primary PLUSPLUS",
"primary : primary MINUSMINUS",
"string : STRING",
"string : string STRING",
"old_style_parm_decls :",
"old_style_parm_decls : datadecls",
"old_style_parm_decls : datadecls ELLIPSIS",
"lineno_datadecl : save_filename save_lineno datadecl",
"datadecls : lineno_datadecl",
"datadecls : errstmt",
"datadecls : datadecls lineno_datadecl",
"datadecls : lineno_datadecl errstmt",
"datadecl : typed_declspecs_no_prefix_attr setspecs initdecls ';'",
"datadecl : declmods_no_prefix_attr setspecs notype_initdecls ';'",
"datadecl : typed_declspecs_no_prefix_attr ';'",
"datadecl : declmods_no_prefix_attr ';'",
"lineno_decl : save_filename save_lineno decl",
"decls : lineno_decl",
"decls : errstmt",
"decls : decls lineno_decl",
"decls : lineno_decl errstmt",
"setspecs :",
"setattrs :",
"decl : typed_declspecs setspecs initdecls ';'",
"decl : declmods setspecs notype_initdecls ';'",
"decl : typed_declspecs setspecs nested_function",
"decl : declmods setspecs notype_nested_function",
"decl : typed_declspecs ';'",
"decl : declmods ';'",
"decl : extension decl",
"typed_declspecs : typespec reserved_declspecs",
"typed_declspecs : declmods typespec reserved_declspecs",
"reserved_declspecs :",
"reserved_declspecs : reserved_declspecs typespecqual_reserved",
"reserved_declspecs : reserved_declspecs SCSPEC",
"reserved_declspecs : reserved_declspecs attributes",
"typed_declspecs_no_prefix_attr : typespec reserved_declspecs_no_prefix_attr",
"typed_declspecs_no_prefix_attr : declmods_no_prefix_attr typespec reserved_declspecs_no_prefix_attr",
"reserved_declspecs_no_prefix_attr :",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr typespecqual_reserved",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr SCSPEC",
"declmods : declmods_no_prefix_attr",
"declmods : attributes",
"declmods : declmods declmods_no_prefix_attr",
"declmods : declmods attributes",
"declmods_no_prefix_attr : type_qualifier",
"declmods_no_prefix_attr : SCSPEC",
"declmods_no_prefix_attr : declmods_no_prefix_attr type_qualifier",
"declmods_no_prefix_attr : declmods_no_prefix_attr SCSPEC",
"type_qualifier : TYPE_QUAL",
"type_qualifier : TYPE_QUAL layout_specifier",
"typed_typespecs : typespec reserved_typespecquals",
"typed_typespecs : nonempty_type_quals typespec reserved_typespecquals",
"layout_specifier : '[' xexpr ']'",
"reserved_typespecquals :",
"reserved_typespecquals : reserved_typespecquals typespecqual_reserved",
"typespec : TYPESPEC",
"typespec : structsp",
"typespec : TYPENAME",
"typespec : TYPEOF '(' expr ')'",
"typespec : TYPEOF '(' typename ')'",
"typespecqual_reserved : TYPESPEC",
"typespecqual_reserved : TYPE_QUAL",
"typespecqual_reserved : structsp",
"initdecls : initdcl",
"initdecls : initdecls ',' initdcl",
"notype_initdecls : notype_initdcl",
"notype_initdecls : notype_initdecls ',' initdcl",
"maybeasm :",
"maybeasm : ASM_KEYWORD '(' string ')'",
"$$16 :",
"initdcl : declarator maybeasm maybe_attribute '=' $$16 init",
"initdcl : declarator maybeasm maybe_attribute",
"$$17 :",
"notype_initdcl : notype_declarator maybeasm maybe_attribute '=' $$17 init",
"notype_initdcl : notype_declarator maybeasm maybe_attribute",
"maybe_attribute :",
"maybe_attribute : attributes",
"attributes : attribute",
"attributes : attributes attribute",
"attribute : ATTRIBUTE '(' '(' attribute_list ')' ')'",
"attribute_list : attrib",
"attribute_list : attribute_list ',' attrib",
"attrib :",
"attrib : any_word",
"attrib : any_word '(' IDENTIFIER ')'",
"attrib : any_word '(' IDENTIFIER ',' nonnull_exprlist ')'",
"attrib : any_word '(' exprlist ')'",
"any_word : identifier",
"any_word : SCSPEC",
"any_word : TYPESPEC",
"any_word : TYPE_QUAL",
"init : expr_no_commas",
"$$18 :",
"init : '{' $$18 initlist_maybe_comma '}'",
"init : error",
"initlist_maybe_comma :",
"initlist_maybe_comma : initlist1 maybecomma",
"initlist1 : initelt",
"initlist1 : initlist1 ',' initelt",
"initelt : designator_list '=' initval",
"initelt : designator initval",
"$$19 :",
"initelt : identifier ':' $$19 initval",
"initelt : initval",
"$$20 :",
"initval : '{' $$20 initlist_maybe_comma '}'",
"initval : expr_no_commas",
"initval : error",
"designator_list : designator",
"designator_list : designator_list designator",
"designator : '.' identifier",
"designator : '[' expr_no_commas ELLIPSIS expr_no_commas ']'",
"designator : '[' expr_no_commas ']'",
"$$21 :",
"$$22 :",
"nested_function : declarator $$21 old_style_parm_decls $$22 compstmt",
"$$23 :",
"$$24 :",
"notype_nested_function : notype_declarator $$23 old_style_parm_decls $$24 compstmt",
"declarator : after_type_declarator",
"declarator : notype_declarator",
"after_type_declarator : '(' after_type_declarator ')'",
"after_type_declarator : after_type_declarator '(' parmlist_or_identifiers",
"after_type_declarator : after_type_declarator '[' expr ']'",
"after_type_declarator : after_type_declarator '[' ']'",
"after_type_declarator : '*' type_quals after_type_declarator",
"after_type_declarator : attributes setattrs after_type_declarator",
"after_type_declarator : TYPENAME",
"parm_declarator : parm_declarator '(' parmlist_or_identifiers",
"parm_declarator : parm_declarator '[' '*' ']'",
"parm_declarator : parm_declarator '[' expr ']'",
"parm_declarator : parm_declarator '[' ']'",
"parm_declarator : '*' type_quals parm_declarator",
"parm_declarator : attributes setattrs parm_declarator",
"parm_declarator : TYPENAME",
"notype_declarator : notype_declarator '(' parmlist_or_identifiers",
"notype_declarator : '(' notype_declarator ')'",
"notype_declarator : '*' type_quals notype_declarator",
"notype_declarator : notype_declarator '[' '*' ']'",
"notype_declarator : notype_declarator '[' expr ']'",
"notype_declarator : notype_declarator '[' ']'",
"notype_declarator : attributes setattrs notype_declarator",
"notype_declarator : IDENTIFIER",
"struct_head : STRUCT",
"struct_head : STRUCT attributes",
"union_head : UNION",
"union_head : UNION attributes",
"enum_head : ENUM",
"enum_head : ENUM attributes",
"$$25 :",
"structsp : struct_head identifier '{' $$25 component_decl_list '}' maybe_attribute",
"structsp : struct_head '{' component_decl_list '}' maybe_attribute",
"structsp : struct_head identifier",
"$$26 :",
"structsp : union_head identifier '{' $$26 component_decl_list '}' maybe_attribute",
"structsp : union_head '{' component_decl_list '}' maybe_attribute",
"structsp : union_head identifier",
"$$27 :",
"structsp : enum_head identifier '{' $$27 enumlist maybecomma_warn '}' maybe_attribute",
"$$28 :",
"structsp : enum_head '{' $$28 enumlist maybecomma_warn '}' maybe_attribute",
"structsp : enum_head identifier",
"maybecomma :",
"maybecomma : ','",
"maybecomma_warn :",
"maybecomma_warn : ','",
"component_decl_list : component_decl_list2",
"component_decl_list : component_decl_list2 component_decl",
"component_decl_list2 :",
"component_decl_list2 : component_decl_list2 component_decl ';'",
"component_decl_list2 : component_decl_list2 ';'",
"component_decl : typed_typespecs setspecs components",
"component_decl : typed_typespecs",
"component_decl : nonempty_type_quals setspecs components",
"component_decl : nonempty_type_quals",
"component_decl : error",
"component_decl : extension component_decl",
"components : component_declarator",
"components : components ',' component_declarator",
"component_declarator : save_filename save_lineno declarator maybe_attribute",
"component_declarator : save_filename save_lineno declarator ':' expr_no_commas maybe_attribute",
"component_declarator : save_filename save_lineno ':' expr_no_commas maybe_attribute",
"enumlist : enumerator",
"enumlist : enumlist ',' enumerator",
"enumlist : error",
"enumerator : identifier",
"enumerator : identifier '=' expr_no_commas",
"typename : typed_typespecs absdcl",
"typename : nonempty_type_quals absdcl",
"absdcl :",
"absdcl : absdcl1",
"nonempty_type_quals : type_qualifier",
"nonempty_type_quals : nonempty_type_quals type_qualifier",
"type_quals :",
"type_quals : type_quals type_qualifier",
"absdcl1 : '(' absdcl1 ')'",
"absdcl1 : '*' type_quals absdcl1",
"absdcl1 : '*' type_quals",
"absdcl1 : absdcl1 '(' parmlist",
"absdcl1 : absdcl1 '[' expr ']'",
"absdcl1 : absdcl1 '[' ']'",
"absdcl1 : '(' parmlist",
"absdcl1 : '[' expr ']'",
"absdcl1 : '[' ']'",
"absdcl1 : attributes setattrs absdcl1",
"stmts : lineno_stmt_or_labels",
"lineno_stmt_or_labels : lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels errstmt",
"xstmts :",
"xstmts : stmts",
"errstmt : error ';'",
"pushlevel :",
"maybe_label_decls :",
"maybe_label_decls : label_decls",
"label_decls : label_decl",
"label_decls : label_decls label_decl",
"label_decl : LABEL identifiers_or_typenames ';'",
"compstmt_or_error : compstmt",
"compstmt_or_error : error compstmt",
"compstmt_start : '{'",
"compstmt : compstmt_start '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls decls xstmts '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls error '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls stmts '}'",
"simple_if : if_prefix lineno_labeled_stmt",
"simple_if : if_prefix error",
"if_prefix : IF '(' expr ')'",
"$$29 :",
"do_stmt_start : DO $$29 lineno_labeled_stmt WHILE",
"save_filename :",
"save_lineno :",
"lineno_labeled_stmt : save_filename save_lineno stmt",
"lineno_labeled_stmt : save_filename save_lineno label lineno_labeled_stmt",
"lineno_stmt_or_label : save_filename save_lineno stmt_or_label",
"stmt_or_label : stmt",
"stmt_or_label : label",
"stmt : compstmt",
"stmt : all_iter_stmt",
"stmt : expr ';'",
"$$30 :",
"stmt : simple_if ELSE $$30 lineno_labeled_stmt",
"stmt : simple_if",
"stmt : simple_if ELSE error",
"$$31 :",
"$$32 :",
"stmt : WHILE $$31 '(' expr ')' $$32 lineno_labeled_stmt",
"stmt : do_stmt_start '(' expr ')' ';'",
"stmt : do_stmt_start error",
"$$33 :",
"$$34 :",
"$$35 :",
"stmt : FOR '(' xexpr ';' $$33 xexpr ';' $$34 xexpr ')' $$35 lineno_labeled_stmt",
"$$36 :",
"$$37 :",
"$$38 :",
"$$39 :",
"stmt : FORALL '(' xexpr ';' $$36 xexpr ';' $$37 xexpr ';' $$38 affinity_expr ')' $$39 lineno_labeled_stmt",
"$$40 :",
"stmt : SWITCH '(' expr ')' $$40 lineno_labeled_stmt",
"stmt : BREAK ';'",
"stmt : CONTINUE ';'",
"stmt : RETURN ';'",
"stmt : RETURN expr ';'",
"stmt : UPC_NOTIFY ';'",
"stmt : UPC_FENCE ';'",
"stmt : UPC_NOTIFY expr ';'",
"stmt : UPC_WAIT ';'",
"stmt : UPC_WAIT expr ';'",
"stmt : UPC_BARRIER ';'",
"stmt : UPC_BARRIER expr ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ':' asm_clobbers ')' ';'",
"stmt : GOTO identifier ';'",
"stmt : GOTO '*' expr ';'",
"stmt : ';'",
"affinity_expr : xexpr",
"affinity_expr : CONTINUE",
"all_iter_stmt : all_iter_stmt_simple",
"$$41 :",
"all_iter_stmt_simple : FOR '(' primary ')' $$41 lineno_labeled_stmt",
"label : CASE expr_no_commas ':'",
"label : CASE expr_no_commas ELLIPSIS expr_no_commas ':'",
"label : DEFAULT ':'",
"label : identifier ':' maybe_attribute",
"maybe_type_qual :",
"maybe_type_qual : TYPE_QUAL",
"xexpr :",
"xexpr : expr",
"xexpr : '*'",
"asm_operands :",
"asm_operands : nonnull_asm_operands",
"nonnull_asm_operands : asm_operand",
"nonnull_asm_operands : nonnull_asm_operands ',' asm_operand",
"asm_operand : STRING '(' expr ')'",
"asm_clobbers : string",
"asm_clobbers : asm_clobbers ',' string",
"$$42 :",
"parmlist : $$42 parmlist_1",
"parmlist_1 : parmlist_2 ')'",
"$$43 :",
"parmlist_1 : parms ';' $$43 parmlist_1",
"parmlist_1 : error ')'",
"parmlist_2 :",
"parmlist_2 : ELLIPSIS",
"parmlist_2 : parms",
"parmlist_2 : parms ',' ELLIPSIS",
"parms : parm",
"parms : parms ',' parm",
"parm : typed_declspecs setspecs parm_declarator maybe_attribute",
"parm : typed_declspecs setspecs notype_declarator maybe_attribute",
"parm : typed_declspecs setspecs absdcl maybe_attribute",
"parm : declmods setspecs notype_declarator maybe_attribute",
"parm : declmods setspecs absdcl maybe_attribute",
"$$44 :",
"parmlist_or_identifiers : $$44 parmlist_or_identifiers_1",
"parmlist_or_identifiers_1 : parmlist_1",
"parmlist_or_identifiers_1 : identifiers ')'",
"identifiers : IDENTIFIER",
"identifiers : identifiers ',' IDENTIFIER",
"identifiers_or_typenames : identifier",
"identifiers_or_typenames : identifiers_or_typenames ',' identifier",
"extension : EXTENSION",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 253 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids an empty source file");
		  finish_file ();
		}
break;
case 2:
#line 258 "../../../gccfe/gnu/c-parse.y"
{
		  /* In case there were missing closebraces,
		     get us back to the global binding level.  */
		  while (! global_bindings_p ())
		    poplevel (0, 0, 0);
		  finish_file ();
		}
break;
case 3:
#line 272 "../../../gccfe/gnu/c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 5:
#line 273 "../../../gccfe/gnu/c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 9:
#line 280 "../../../gccfe/gnu/c-parse.y"
{ STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    assemble_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 10:
#line 288 "../../../gccfe/gnu/c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 11:
#line 293 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    error ("ANSI C forbids data definition with no type or storage class");
		  else if (!flag_traditional)
		    warning ("data definition has no type or storage class"); 

		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 12:
#line 303 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 13:
#line 308 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 14:
#line 313 "../../../gccfe/gnu/c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 15:
#line 315 "../../../gccfe/gnu/c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 18:
#line 319 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C does not allow extra `;' outside of a function"); }
break;
case 19:
#line 325 "../../../gccfe/gnu/c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 20:
#line 330 "../../../gccfe/gnu/c-parse.y"
{ store_parm_decls (); }
break;
case 21:
#line 332 "../../../gccfe/gnu/c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 22:
#line 338 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 23:
#line 343 "../../../gccfe/gnu/c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 24:
#line 348 "../../../gccfe/gnu/c-parse.y"
{ store_parm_decls (); }
break;
case 25:
#line 350 "../../../gccfe/gnu/c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 26:
#line 356 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 27:
#line 361 "../../../gccfe/gnu/c-parse.y"
{ if (! start_function (NULL_TREE, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 28:
#line 366 "../../../gccfe/gnu/c-parse.y"
{ store_parm_decls (); }
break;
case 29:
#line 368 "../../../gccfe/gnu/c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 30:
#line 374 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 33:
#line 386 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = ADDR_EXPR; }
break;
case 34:
#line 388 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = NEGATE_EXPR; }
break;
case 35:
#line 390 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = CONVERT_EXPR; }
break;
case 36:
#line 392 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = PREINCREMENT_EXPR; }
break;
case 37:
#line 394 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = PREDECREMENT_EXPR; }
break;
case 38:
#line 396 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = BIT_NOT_EXPR; }
break;
case 39:
#line 398 "../../../gccfe/gnu/c-parse.y"
{ yyval.code = TRUTH_NOT_EXPR; }
break;
case 40:
#line 402 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_compound_expr (yyvsp[0].ttype); }
break;
case 41:
#line 407 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 43:
#line 413 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 44:
#line 415 "../../../gccfe/gnu/c-parse.y"
{ chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 46:
#line 421 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_indirect_ref (yyvsp[0].ttype, "unary *"); }
break;
case 47:
#line 424 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 48:
#line 427 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_unary_op (yyvsp[-1].code, yyvsp[0].ttype, 0);
		  overflow_warning (yyval.ttype); }
break;
case 49:
#line 431 "../../../gccfe/gnu/c-parse.y"
{ tree label = lookup_label (yyvsp[0].ttype);
		  if (pedantic)
		    pedwarn ("ANSI C forbids `&&'");
		  if (label == 0)
		    yyval.ttype = null_pointer_node;
		  else
		    {
		      TREE_USED (label) = 1;
		      yyval.ttype = build1 (ADDR_EXPR, ptr_type_node, label);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 50:
#line 459 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = c_sizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 51:
#line 465 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_sizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 52:
#line 469 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = upc_blocksizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 53:
#line 475 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_blocksizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 54:
#line 478 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = upc_localsizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 55:
#line 484 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_localsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 56:
#line 487 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = upc_elemsizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 57:
#line 493 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_elemsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 58:
#line 497 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof_expr (yyvsp[0].ttype); }
break;
case 59:
#line 500 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof (groktypename (yyvsp[-1].ttype)); }
break;
case 60:
#line 503 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_unary_op (REALPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 61:
#line 505 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_unary_op (IMAGPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 62:
#line 510 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation++; }
break;
case 63:
#line 513 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation++; }
break;
case 64:
#line 516 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation++; }
break;
case 65:
#line 519 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation++; }
break;
case 66:
#line 524 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation++; }
break;
case 68:
#line 530 "../../../gccfe/gnu/c-parse.y"
{ tree type = groktypename (yyvsp[-2].ttype);
		  yyval.ttype = build_c_cast (type, yyvsp[0].ttype); }
break;
case 69:
#line 533 "../../../gccfe/gnu/c-parse.y"
{ start_init (NULL_TREE, NULL, 0);
		  yyvsp[-2].ttype = groktypename (yyvsp[-2].ttype);
		  really_start_incremental_init (yyvsp[-2].ttype); }
break;
case 70:
#line 537 "../../../gccfe/gnu/c-parse.y"
{ char *name;
		  tree result = pop_init_level (0);
		  tree type = yyvsp[-5].ttype;
		  finish_init ();

		  if (pedantic && ! flag_isoc99)
		    pedwarn ("ANSI C forbids constructor expressions");
		  if (TYPE_NAME (type) != 0)
		    {
		      if (TREE_CODE (TYPE_NAME (type)) == IDENTIFIER_NODE)
			name = IDENTIFIER_POINTER (TYPE_NAME (type));
		      else
			name = IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type)));
		    }
		  else
		    name = "";
		  yyval.ttype = result;
		  if (TREE_CODE (type) == ARRAY_TYPE && TYPE_SIZE (type) == 0)
		    {
		      int failure = complete_array_type (type, yyval.ttype, 1);
		      if (failure)
			abort ();
		    }
		}
break;
case 72:
#line 566 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 73:
#line 568 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 74:
#line 570 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 75:
#line 572 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 76:
#line 574 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 77:
#line 576 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 78:
#line 578 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 79:
#line 580 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 80:
#line 582 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 81:
#line 584 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 82:
#line 586 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 83:
#line 588 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 84:
#line 590 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 85:
#line 593 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_false_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ANDIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 86:
#line 596 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 87:
#line 599 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_true_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ORIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 88:
#line 602 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 89:
#line 605 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation += ((yyvsp[-4].ttype == boolean_true_node)
				      - (yyvsp[-4].ttype == boolean_false_node)); }
break;
case 90:
#line 608 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation -= yyvsp[-6].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-6].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 91:
#line 611 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids omitting the middle term of a ?: expression");
		  /* Make sure first operand is calculated only once.  */
		  yyvsp[0].ttype = save_expr (yyvsp[-1].ttype);
		  yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[0].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 92:
#line 618 "../../../gccfe/gnu/c-parse.y"
{ skip_evaluation -= yyvsp[-4].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 93:
#line 621 "../../../gccfe/gnu/c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, NOP_EXPR, yyvsp[0].ttype);
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, MODIFY_EXPR);
		}
break;
case 94:
#line 629 "../../../gccfe/gnu/c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, yyvsp[-1].code, yyvsp[0].ttype);
		  /* This inhibits warnings in truthvalue_conversion.  */
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, ERROR_MARK);
		}
break;
case 95:
#line 641 "../../../gccfe/gnu/c-parse.y"
{
		  yyval.ttype = lastiddecl;
		  if (!yyval.ttype || yyval.ttype == error_mark_node)
		    {
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			    {
			      /* Ordinary implicit function declaration.  */
			      yyval.ttype = implicitly_declare (yyvsp[0].ttype);
			      assemble_external (yyval.ttype);
			      TREE_USED (yyval.ttype) = 1;
			    }
			}
		      else if (current_function_decl == 0)
			{
			  error ("`%s' undeclared here (not in a function)",
				 IDENTIFIER_POINTER (yyvsp[0].ttype));
			  yyval.ttype = error_mark_node;
			}
		      else
			{
			    {
			      if (IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) != error_mark_node
				  || IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) != current_function_decl)
				{
				  error ("`%s' undeclared (first use in this function)",
					 IDENTIFIER_POINTER (yyvsp[0].ttype));

				  if (! undeclared_variable_notice)
				    {
				      error ("(Each undeclared identifier is reported only once");
				      error ("for each function it appears in.)");
				      undeclared_variable_notice = 1;
				    }
				}
			      yyval.ttype = error_mark_node;
			      /* Prevent repeated error messages.  */
			      IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) = error_mark_node;
			      IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) = current_function_decl;
			    }
			}
		    }
		  else if (TREE_TYPE (yyval.ttype) == error_mark_node)
		    yyval.ttype = error_mark_node;
		  else if (C_DECL_ANTICIPATED (yyval.ttype))
		    {
		      /* The first time we see a build-in function used,
			 if it has not been declared.  */
		      C_DECL_ANTICIPATED (yyval.ttype) = 0;
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			  /* Omit the implicit declaration we
			     would ordinarily do, so we don't lose
			     the actual built in type.
			     But print a diagnostic for the mismatch.  */
			    if (TREE_CODE (yyval.ttype) != FUNCTION_DECL)
			      error ("`%s' implicitly declared as function",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  else if ((TYPE_MODE (TREE_TYPE (TREE_TYPE (yyval.ttype)))
				    != TYPE_MODE (integer_type_node))
				   && (TREE_TYPE (TREE_TYPE (yyval.ttype))
				       != void_type_node))
			    pedwarn ("type mismatch in implicit declaration for built-in function `%s'",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  /* If it really returns void, change that to int.  */
			  if (TREE_TYPE (TREE_TYPE (yyval.ttype)) == void_type_node)
			    TREE_TYPE (yyval.ttype)
			      = build_function_type (integer_type_node,
						     TYPE_ARG_TYPES (TREE_TYPE (yyval.ttype)));
			}
		      else
			pedwarn ("built-in function `%s' used without declaration",
				 IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));

		      /* Do what we would ordinarily do when a fn is used.  */
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }
		  else
		    {
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }

		  if (TREE_CODE (yyval.ttype) == CONST_DECL)
		    {
		      yyval.ttype = DECL_INITIAL (yyval.ttype);
		      /* This is to prevent an enum whose value is 0
			 from being considered a null pointer constant.  */
		      yyval.ttype = build1 (NOP_EXPR, TREE_TYPE (yyval.ttype), yyval.ttype);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 97:
#line 740 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = combine_strings (yyvsp[0].ttype); }
break;
case 98:
#line 742 "../../../gccfe/gnu/c-parse.y"
{ char class = TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyvsp[-1].ttype, ERROR_MARK);
		  yyval.ttype = yyvsp[-1].ttype; }
break;
case 99:
#line 748 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 100:
#line 750 "../../../gccfe/gnu/c-parse.y"
{ if (current_function_decl == 0)
		    {
		      error ("braced-group within expression allowed only inside a function");
		      YYERROR;
		    }
		  /* We must force a BLOCK for this level
		     so that, if it is not expanded later,
		     there is a way to turn off the entire subtree of blocks
		     that are contained in it.  */
		  keep_next_level ();
		  push_iterator_stack ();
		  push_label_level ();
		  yyval.ttype = expand_start_stmt_expr (); }
break;
case 101:
#line 764 "../../../gccfe/gnu/c-parse.y"
{ tree rtl_exp;
		  if (pedantic)
		    pedwarn ("ANSI C forbids braced-groups within expressions");
		  pop_iterator_stack ();
		  pop_label_level ();
		  rtl_exp = expand_end_stmt_expr (yyvsp[-2].ttype);
		  /* The statements have side effects, so the group does.  */
		  TREE_SIDE_EFFECTS (rtl_exp) = 1;

		  if (TREE_CODE (yyvsp[-1].ttype) == BLOCK)
		    {
		      /* Make a BIND_EXPR for the BLOCK already made.  */
		      yyval.ttype = build (BIND_EXPR, TREE_TYPE (rtl_exp),
				  NULL_TREE, rtl_exp, yyvsp[-1].ttype);
		      /* Remove the block from the tree at this point.
			 It gets put back at the proper place
			 when the BIND_EXPR is expanded.  */
		      delete_block (yyvsp[-1].ttype);
		    }
		  else
		    yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 102:
#line 787 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_function_call (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 103:
#line 789 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_array_ref (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 104:
#line 791 "../../../gccfe/gnu/c-parse.y"
{
		    yyval.ttype = build_component_ref (yyvsp[-2].ttype, yyvsp[0].ttype);
		}
break;
case 105:
#line 795 "../../../gccfe/gnu/c-parse.y"
{
                  tree expr = build_indirect_ref (yyvsp[-2].ttype, "->");

                    yyval.ttype = build_component_ref (expr, yyvsp[0].ttype);
		}
break;
case 106:
#line 801 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_unary_op (POSTINCREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 107:
#line 803 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_unary_op (POSTDECREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 109:
#line 810 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 112:
#line 819 "../../../gccfe/gnu/c-parse.y"
{ c_mark_varargs ();
		  if (pedantic)
		    pedwarn ("ANSI C does not permit use of `varargs.h'"); }
break;
case 113:
#line 829 "../../../gccfe/gnu/c-parse.y"
{ }
break;
case 118:
#line 845 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 119:
#line 850 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);	
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 120:
#line 855 "../../../gccfe/gnu/c-parse.y"
{ shadow_tag_warned (yyvsp[-1].ttype, 1);
		  pedwarn ("empty declaration"); }
break;
case 121:
#line 858 "../../../gccfe/gnu/c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 122:
#line 867 "../../../gccfe/gnu/c-parse.y"
{ }
break;
case 127:
#line 882 "../../../gccfe/gnu/c-parse.y"
{ yyval.itype = suspend_momentary ();
		  pending_xref_error ();
		  declspec_stack = tree_cons (prefix_attributes,
					      current_declspecs,
					      declspec_stack);
		  split_specs_attrs (yyvsp[0].ttype,
				     &current_declspecs, &prefix_attributes); }
break;
case 128:
#line 893 "../../../gccfe/gnu/c-parse.y"
{ prefix_attributes = chainon (prefix_attributes, yyvsp[0].ttype); }
break;
case 129:
#line 898 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 130:
#line 903 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 131:
#line 908 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 132:
#line 913 "../../../gccfe/gnu/c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 133:
#line 918 "../../../gccfe/gnu/c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 134:
#line 920 "../../../gccfe/gnu/c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 135:
#line 922 "../../../gccfe/gnu/c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 136:
#line 932 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 137:
#line 934 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 138:
#line 938 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 139:
#line 940 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 140:
#line 942 "../../../gccfe/gnu/c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 141:
#line 947 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 142:
#line 952 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 143:
#line 954 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 144:
#line 959 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 145:
#line 961 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 146:
#line 963 "../../../gccfe/gnu/c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 147:
#line 976 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 148:
#line 978 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); }
break;
case 149:
#line 980 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 150:
#line 982 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 151:
#line 987 "../../../gccfe/gnu/c-parse.y"
{ TREE_STATIC (yyval.ttype) = 1; }
break;
case 152:
#line 989 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 153:
#line 991 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = 1; }
break;
case 154:
#line 994 "../../../gccfe/gnu/c-parse.y"
{ if (extra_warnings && TREE_STATIC (yyvsp[-1].ttype))
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); }
break;
case 155:
#line 1003 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 156:
#line 1005 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
				 tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 157:
#line 1016 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 158:
#line 1018 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 159:
#line 1024 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons(NULL_TREE, yyvsp[-1].ttype, NULL_TREE); }
break;
case 160:
#line 1027 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 161:
#line 1029 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 164:
#line 1039 "../../../gccfe/gnu/c-parse.y"
{ /* For a typedef name, record the meaning, not the name.
		     In case of `foo foo, bar;'.  */
		  yyval.ttype = lookup_name (yyvsp[0].ttype); }
break;
case 165:
#line 1043 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = TREE_TYPE (yyvsp[-1].ttype); }
break;
case 166:
#line 1045 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = groktypename (yyvsp[-1].ttype); }
break;
case 174:
#line 1068 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 175:
#line 1070 "../../../gccfe/gnu/c-parse.y"
{ if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype);
		  yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 176:
#line 1077 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 177:
#line 1082 "../../../gccfe/gnu/c-parse.y"
{ finish_init ();
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 178:
#line 1085 "../../../gccfe/gnu/c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); 
                }
break;
case 179:
#line 1093 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 180:
#line 1098 "../../../gccfe/gnu/c-parse.y"
{ finish_init ();
		  decl_attributes (yyvsp[-1].ttype, yyvsp[-3].ttype, prefix_attributes);
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 181:
#line 1102 "../../../gccfe/gnu/c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); }
break;
case 182:
#line 1110 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 183:
#line 1112 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 184:
#line 1117 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 185:
#line 1119 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 186:
#line 1124 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[-2].ttype; }
break;
case 187:
#line 1129 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 188:
#line 1131 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 189:
#line 1136 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 190:
#line 1138 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, NULL_TREE); }
break;
case 191:
#line 1140 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, build_tree_list (NULL_TREE, yyvsp[-1].ttype)); }
break;
case 192:
#line 1142 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-5].ttype, tree_cons (NULL_TREE, yyvsp[-3].ttype, yyvsp[-1].ttype)); }
break;
case 193:
#line 1144 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 199:
#line 1162 "../../../gccfe/gnu/c-parse.y"
{ really_start_incremental_init (NULL_TREE);
		  /* Note that the call to clear_momentary
		     is in process_init_element.  */
		  push_momentary (); }
break;
case 200:
#line 1167 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = pop_init_level (0);
		  if (yyval.ttype == error_mark_node
		      && ! (yychar == STRING || yychar == CONSTANT))
		    pop_momentary ();
		  else
		    pop_momentary_nofree (); }
break;
case 201:
#line 1175 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 202:
#line 1181 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids empty initializer braces"); }
break;
case 208:
#line 1197 "../../../gccfe/gnu/c-parse.y"
{ set_init_label (yyvsp[-1].ttype); }
break;
case 211:
#line 1204 "../../../gccfe/gnu/c-parse.y"
{ push_init_level (0); }
break;
case 212:
#line 1206 "../../../gccfe/gnu/c-parse.y"
{ process_init_element (pop_init_level (0)); }
break;
case 213:
#line 1208 "../../../gccfe/gnu/c-parse.y"
{ process_init_element (yyvsp[0].ttype); }
break;
case 217:
#line 1219 "../../../gccfe/gnu/c-parse.y"
{ set_init_label (yyvsp[0].ttype); }
break;
case 218:
#line 1224 "../../../gccfe/gnu/c-parse.y"
{ set_init_index (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 219:
#line 1226 "../../../gccfe/gnu/c-parse.y"
{ set_init_index (yyvsp[-1].ttype, NULL_TREE); }
break;
case 220:
#line 1231 "../../../gccfe/gnu/c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 221:
#line 1240 "../../../gccfe/gnu/c-parse.y"
{ store_parm_decls (); }
break;
case 222:
#line 1248 "../../../gccfe/gnu/c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 223:
#line 1254 "../../../gccfe/gnu/c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 224:
#line 1263 "../../../gccfe/gnu/c-parse.y"
{ store_parm_decls (); }
break;
case 225:
#line 1271 "../../../gccfe/gnu/c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 228:
#line 1287 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 229:
#line 1289 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 230:
#line 1294 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 231:
#line 1296 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 232:
#line 1298 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 233:
#line 1305 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 235:
#line 1316 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 236:
#line 1321 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 237:
#line 1326 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 238:
#line 1328 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 239:
#line 1330 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 240:
#line 1337 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 242:
#line 1346 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 243:
#line 1351 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 244:
#line 1353 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 245:
#line 1355 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 246:
#line 1360 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 247:
#line 1362 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 248:
#line 1369 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 250:
#line 1375 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 251:
#line 1377 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 252:
#line 1382 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 253:
#line 1384 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 254:
#line 1389 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 255:
#line 1391 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 256:
#line 1396 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = start_struct (RECORD_TYPE, yyvsp[-1].ttype);
		  /* Start scope of tag before parsing components.  */
		}
break;
case 257:
#line 1400 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype)); }
break;
case 258:
#line 1402 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = finish_struct (start_struct (RECORD_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		}
break;
case 259:
#line 1406 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = xref_tag (RECORD_TYPE, yyvsp[0].ttype); }
break;
case 260:
#line 1408 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = start_struct (UNION_TYPE, yyvsp[-1].ttype); }
break;
case 261:
#line 1410 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype)); }
break;
case 262:
#line 1412 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = finish_struct (start_struct (UNION_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		}
break;
case 263:
#line 1416 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = xref_tag (UNION_TYPE, yyvsp[0].ttype); }
break;
case 264:
#line 1418 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (yyvsp[-1].ttype); }
break;
case 265:
#line 1421 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-7].ttype, yyvsp[0].ttype));
		  resume_momentary (yyvsp[-5].itype); }
break;
case 266:
#line 1424 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (NULL_TREE); }
break;
case 267:
#line 1427 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  resume_momentary (yyvsp[-5].itype); }
break;
case 268:
#line 1430 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = xref_tag (ENUMERAL_TYPE, yyvsp[0].ttype); }
break;
case 272:
#line 1441 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic && ! flag_isoc99)
		    pedwarn ("comma at end of enumerator list"); }
break;
case 273:
#line 1447 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 274:
#line 1449 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype);
		  pedwarn ("no semicolon at end of struct or union"); }
break;
case 275:
#line 1454 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 276:
#line 1456 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[-1].ttype); }
break;
case 277:
#line 1458 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("extra semicolon in struct or union specified"); }
break;
case 278:
#line 1473 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 279:
#line 1479 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 280:
#line 1484 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 281:
#line 1490 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 282:
#line 1495 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 283:
#line 1497 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 285:
#line 1504 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 286:
#line 1509 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-3].filename, yyvsp[-2].lineno, yyvsp[-1].ttype, current_declspecs, NULL_TREE);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 287:
#line 1513 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-5].filename, yyvsp[-4].lineno, yyvsp[-3].ttype, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 288:
#line 1516 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-4].filename, yyvsp[-3].lineno, NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 290:
#line 1528 "../../../gccfe/gnu/c-parse.y"
{ if (yyvsp[-2].ttype == error_mark_node)
		    yyval.ttype = yyvsp[-2].ttype;
		  else
		    yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-2].ttype); }
break;
case 291:
#line 1533 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 292:
#line 1539 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[0].ttype, NULL_TREE); }
break;
case 293:
#line 1541 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 294:
#line 1546 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 295:
#line 1548 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 296:
#line 1553 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 299:
#line 1560 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 300:
#line 1565 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 301:
#line 1567 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 302:
#line 1572 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 303:
#line 1575 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 304:
#line 1577 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); }
break;
case 305:
#line 1579 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 306:
#line 1581 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 307:
#line 1583 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 308:
#line 1585 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 309:
#line 1587 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); }
break;
case 310:
#line 1589 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, NULL_TREE); }
break;
case 311:
#line 1593 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 312:
#line 1602 "../../../gccfe/gnu/c-parse.y"
{
		  if (pedantic && yyvsp[0].ends_in_label)
		    pedwarn ("ANSI C forbids label at end of compound statement");
		}
break;
case 314:
#line 1611 "../../../gccfe/gnu/c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 315:
#line 1613 "../../../gccfe/gnu/c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 319:
#line 1625 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  pushlevel (0);
		  clear_last_expr ();
		  push_momentary ();
		  UPC_statement_pragma_ok = 0;
		  expand_start_bindings (0);
		}
break;
case 321:
#line 1639 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids label declarations"); }
break;
case 324:
#line 1650 "../../../gccfe/gnu/c-parse.y"
{ tree link;
		  for (link = yyvsp[-1].ttype; link; link = TREE_CHAIN (link))
		    {
		      tree label = shadow_label (TREE_VALUE (link));
		      C_DECLARED_LABEL_FLAG (label) = 1;
		      declare_nonlocal_label (label);
		    }
		}
break;
case 325:
#line 1664 "../../../gccfe/gnu/c-parse.y"
{}
break;
case 327:
#line 1668 "../../../gccfe/gnu/c-parse.y"
{ 
	  push_consistency_nesting_level (1);
	  UPC_statement_pragma_ok = 1;
	  compstmt_count++; }
break;
case 328:
#line 1674 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = convert (void_type_node, integer_zero_node);
		pop_consistency_nesting_level (1);	}
break;
case 329:
#line 1677 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), 1, 0);
		  yyval.ttype = poplevel (1, 1, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  pop_consistency_nesting_level (1);	}
break;
case 330:
#line 1686 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  pop_consistency_nesting_level (1); }
break;
case 331:
#line 1695 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); 
		  pop_consistency_nesting_level (1);	}
break;
case 334:
#line 1716 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_cond (truthvalue_conversion (yyvsp[-1].ttype), 0, 
				       compstmt_count);
		  yyval.itype = stmt_count;
		  if_stmt_file = yyvsp[-5].filename;
		  if_stmt_line = yyvsp[-4].lineno;
		  position_after_white_space (); }
break;
case 335:
#line 1730 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  compstmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  expand_start_loop_continue_elsewhere (1);
		  position_after_white_space (); }
break;
case 336:
#line 1738 "../../../gccfe/gnu/c-parse.y"
{ expand_loop_continue_here (); }
break;
case 337:
#line 1742 "../../../gccfe/gnu/c-parse.y"
{ yyval.filename = input_filename; }
break;
case 338:
#line 1746 "../../../gccfe/gnu/c-parse.y"
{ yyval.lineno = lineno; }
break;
case 339:
#line 1751 "../../../gccfe/gnu/c-parse.y"
{ }
break;
case 340:
#line 1756 "../../../gccfe/gnu/c-parse.y"
{ }
break;
case 341:
#line 1761 "../../../gccfe/gnu/c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 342:
#line 1766 "../../../gccfe/gnu/c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 343:
#line 1768 "../../../gccfe/gnu/c-parse.y"
{ yyval.ends_in_label = 1; }
break;
case 344:
#line 1774 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++; }
break;
case 346:
#line 1777 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
/* It appears that this should not be done--that a non-lvalue array
   shouldn't get an error if the value isn't used.
   Section 3.2.2.1 says that an array lvalue gets converted to a pointer
   if it appears as a top-level expression,
   but says nothing about non-lvalue arrays.  */
#if 0
		  /* Call default_conversion to get an error
		     on referring to a register array if pedantic.  */
		  if (TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == ARRAY_TYPE
		      || TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == FUNCTION_TYPE)
		    yyvsp[-1].ttype = default_conversion (yyvsp[-1].ttype);
#endif
		  iterator_expand (yyvsp[-1].ttype);
		  clear_momentary (); }
break;
case 347:
#line 1794 "../../../gccfe/gnu/c-parse.y"
{ c_expand_start_else ();
		  yyvsp[-1].itype = stmt_count;
		  position_after_white_space (); }
break;
case 348:
#line 1798 "../../../gccfe/gnu/c-parse.y"
{ c_expand_end_cond ();
		  if (extra_warnings && stmt_count == yyvsp[-3].itype)
		    warning ("empty body in an else-statement"); }
break;
case 349:
#line 1802 "../../../gccfe/gnu/c-parse.y"
{ c_expand_end_cond ();
		  /* This warning is here instead of in simple_if, because we
		     do not want a warning if an empty if is followed by an
		     else statement.  Increment stmt_count so we don't
		     give a second error if this is a nested `if'.  */
		  if (extra_warnings && stmt_count++ == yyvsp[0].itype)
		    warning_with_file_and_line (if_stmt_file, if_stmt_line,
						"empty body in an if-statement"); }
break;
case 350:
#line 1814 "../../../gccfe/gnu/c-parse.y"
{ c_expand_end_cond (); }
break;
case 351:
#line 1816 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* The emit_nop used to come before emit_line_note,
		     but that made the nop seem like part of the preceding line.
		     And that was confusing when the preceding line was
		     inside of an if statement and was not really executed.
		     I think it ought to work to put the nop after the line number.
		     We will see.  --rms, July 15, 1991.  */
		  emit_nop (); }
break;
case 352:
#line 1826 "../../../gccfe/gnu/c-parse.y"
{ /* Don't start the loop till we have succeeded
		     in parsing the end test.  This is to make sure
		     that we end every loop we start.  */
		  expand_start_loop (1);
		  emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-1].ttype));
		  position_after_white_space (); }
break;
case 353:
#line 1835 "../../../gccfe/gnu/c-parse.y"
{ expand_end_loop (); }
break;
case 354:
#line 1838 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-2].ttype));
		  expand_end_loop ();
		  clear_momentary (); }
break;
case 355:
#line 1845 "../../../gccfe/gnu/c-parse.y"
{ expand_end_loop ();
		  clear_momentary (); }
break;
case 356:
#line 1849 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[-1].ttype) c_expand_expr_stmt (yyvsp[-1].ttype);
		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 357:
#line 1861 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 358:
#line 1864 "../../../gccfe/gnu/c-parse.y"
{ 
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  /* Emit the end-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-4].ttype)
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-4].ttype));
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 359:
#line 1880 "../../../gccfe/gnu/c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		  if (yyvsp[-3].ttype)
		    c_expand_expr_stmt (yyvsp[-3].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  expand_end_loop (); }
break;
case 360:
#line 1892 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[-1].ttype) c_expand_expr_stmt (yyvsp[-1].ttype);
		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 361:
#line 1904 "../../../gccfe/gnu/c-parse.y"
{ yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 362:
#line 1907 "../../../gccfe/gnu/c-parse.y"
{ 
		/* Can't emit now; wait till after expand_start_loop...  */
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 363:
#line 1912 "../../../gccfe/gnu/c-parse.y"
{
		  /* The xexpr of $12 is the affinity expression that
		     determines which thread executes a given iteration
		     of the FORALL loop.  It can evaluate either to a
		     shared address with a thread component or to an
		     integer in the range 0-(THREADS-1), inclusive.  The
		     thread component or the integer will specify the
		     executing thread. */
		  /* In the current implementation the FORALL loop body
		     will be wrapped inside a runtime conditional.  In
		     an unoptimized version, each thread will execute every
		     loop iteration of the loop, deciding on each iteration
		     whether to execute the body or to do the equivalent
		     of "continue" if the affinity is wrong. */
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  
		    /* Emit the affinity-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-1].ttype)
		    expand_affinity_test (yyvsp[-1].ttype);

		  /* Emit the end-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-7].ttype)
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-7].ttype));
		
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 364:
#line 1948 "../../../gccfe/gnu/c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		  if (yyvsp[-6].ttype)
		    c_expand_expr_stmt (yyvsp[-6].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  expand_end_loop (); }
break;
case 365:
#line 1959 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_case (yyvsp[-1].ttype);
		  /* Don't let the tree nodes for $3 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  position_after_white_space (); }
break;
case 366:
#line 1967 "../../../gccfe/gnu/c-parse.y"
{ expand_end_case (yyvsp[-3].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); }
break;
case 367:
#line 1973 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if ( ! expand_exit_something ())
		    error ("break statement not within loop or switch"); }
break;
case 368:
#line 1978 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if (! expand_continue_loop (NULL_PTR))
		    error ("continue statement not within a loop"); }
break;
case 369:
#line 1983 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  c_expand_return (NULL_TREE); }
break;
case 370:
#line 1987 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  c_expand_return (yyvsp[-1].ttype); }
break;
case 371:
#line 1991 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (1, NULL_TREE); }
break;
case 372:
#line 1995 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (4, NULL_TREE); }
break;
case 373:
#line 1999 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (1, yyvsp[-1].ttype); }
break;
case 374:
#line 2003 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (2, NULL_TREE); }
break;
case 375:
#line 2007 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (2, yyvsp[-1].ttype); }
break;
case 376:
#line 2011 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (3, NULL_TREE); }
break;
case 377:
#line 2015 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (3, yyvsp[-1].ttype); }
break;
case 378:
#line 2019 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-7].filename, yyvsp[-6].lineno);
		  STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    expand_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 379:
#line 2030 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-9].filename, yyvsp[-8].lineno);
		  c_expand_asm_operands (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
					 yyvsp[-6].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 380:
#line 2037 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-11].filename, yyvsp[-10].lineno);
		  c_expand_asm_operands (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
					 yyvsp[-8].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 381:
#line 2045 "../../../gccfe/gnu/c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-13].filename, yyvsp[-12].lineno);
		  c_expand_asm_operands (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype,
					 yyvsp[-10].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 382:
#line 2051 "../../../gccfe/gnu/c-parse.y"
{ tree decl;
		  stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  decl = lookup_label (yyvsp[-1].ttype);
		  if (decl != 0)
		    {
		      TREE_USED (decl) = 1;
		      expand_goto (decl);
		    }
		}
break;
case 383:
#line 2062 "../../../gccfe/gnu/c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids `goto *expr;'");
		  stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  expand_computed_goto (convert (ptr_type_node, yyvsp[-1].ttype)); }
break;
case 386:
#line 2073 "../../../gccfe/gnu/c-parse.y"
{yyval.ttype = NULL_TREE;}
break;
case 388:
#line 2083 "../../../gccfe/gnu/c-parse.y"
{
	    /* The value returned by this action is  */
	    /*      1 if everything is OK */ 
	    /*      0 in case of error or already bound iterator */

	    yyval.itype = 0;
	    if (TREE_CODE (yyvsp[-1].ttype) != VAR_DECL)
	      error ("invalid `for (ITERATOR)' syntax");
	    else if (! ITERATOR_P (yyvsp[-1].ttype))
	      error ("`%s' is not an iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else if (ITERATOR_BOUND_P (yyvsp[-1].ttype))
	      error ("`for (%s)' inside expansion of same iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else
	      {
		yyval.itype = 1;
		iterator_for_loop_start (yyvsp[-1].ttype);
	      }
	  }
break;
case 389:
#line 2104 "../../../gccfe/gnu/c-parse.y"
{
	    if (yyvsp[-1].itype)
	      iterator_for_loop_end (yyvsp[-3].ttype);
	  }
break;
case 390:
#line 2139 "../../../gccfe/gnu/c-parse.y"
{ register tree value = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  stmt_count++;

		  if (value != error_mark_node)
		    {
		      tree duplicate;
		      int success;

		      if (pedantic && ! INTEGRAL_TYPE_P (TREE_TYPE (value)))
			pedwarn ("label must have integral type in ANSI C");

		      success = pushcase (value, convert_and_check,
					  label, &duplicate);

		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 391:
#line 2170 "../../../gccfe/gnu/c-parse.y"
{ register tree value1 = check_case_value (yyvsp[-3].ttype);
		  register tree value2 = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  if (pedantic)
		    pedwarn ("ANSI C forbids case ranges");
		  stmt_count++;

		  if (value1 != error_mark_node && value2 != error_mark_node)
		    {
		      tree duplicate;
		      int success = pushcase_range (value1, value2,
						    convert_and_check, label,
						    &duplicate);
		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 4)
			warning ("empty case range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 392:
#line 2201 "../../../gccfe/gnu/c-parse.y"
{
		  tree duplicate;
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);
		  int success = pushcase (NULL_TREE, 0, label, &duplicate);
		  stmt_count++;
		  if (success == 1)
		    error ("default label not within a switch statement");
		  else if (success == 2)
		    {
		      error ("multiple default labels in one switch");
		      error_with_decl (duplicate, "this is the first default label");
		    }
		  position_after_white_space (); }
break;
case 393:
#line 2216 "../../../gccfe/gnu/c-parse.y"
{ tree label = define_label (input_filename, lineno, yyvsp[-2].ttype);
		  stmt_count++;
		  emit_nop ();
		  if (label)
		    {
		      expand_label (label);
		      decl_attributes (label, yyvsp[0].ttype, NULL_TREE);
		    }
		  position_after_white_space (); }
break;
case 394:
#line 2231 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno);
		  yyval.ttype = NULL_TREE; }
break;
case 395:
#line 2234 "../../../gccfe/gnu/c-parse.y"
{ emit_line_note (input_filename, lineno); }
break;
case 396:
#line 2239 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 398:
#line 2243 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_int_2(-1, 0); }
break;
case 399:
#line 2249 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 402:
#line 2256 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 403:
#line 2261 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 404:
#line 2266 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), NULL_TREE); }
break;
case 405:
#line 2268 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), yyvsp[-2].ttype); }
break;
case 406:
#line 2274 "../../../gccfe/gnu/c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (0); }
break;
case 407:
#line 2278 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 409:
#line 2286 "../../../gccfe/gnu/c-parse.y"
{ tree parm;
		  if (pedantic)
		    pedwarn ("ANSI C forbids forward parameter declarations");
		  /* Mark the forward decls as such.  */
		  for (parm = getdecls (); parm; parm = TREE_CHAIN (parm))
		    TREE_ASM_WRITTEN (parm) = 1;
		  clear_parm_order (); }
break;
case 410:
#line 2294 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 411:
#line 2296 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, NULL_TREE); }
break;
case 412:
#line 2302 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 413:
#line 2304 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = get_parm_info (0);
		  /* Gcc used to allow this as an extension.  However, it does
		     not work for all targets, and thus has been disabled.
		     Also, since func (...) and func () are indistinguishable,
		     it caused problems with the code in expand_builtin which
		     tries to verify that BUILT_IN_NEXT_ARG is being used
		     correctly.  */
		  error ("ANSI C requires a named argument before `...'");
		}
break;
case 414:
#line 2314 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = get_parm_info (1); }
break;
case 415:
#line 2316 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 416:
#line 2321 "../../../gccfe/gnu/c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 417:
#line 2323 "../../../gccfe/gnu/c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 418:
#line 2330 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 419:
#line 2339 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype)); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 420:
#line 2348 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 421:
#line 2357 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 422:
#line 2367 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 423:
#line 2381 "../../../gccfe/gnu/c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (1); }
break;
case 424:
#line 2385 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 426:
#line 2393 "../../../gccfe/gnu/c-parse.y"
{ tree t;
		  for (t = yyvsp[-1].ttype; t; t = TREE_CHAIN (t))
		    if (TREE_VALUE (t) == NULL_TREE)
		      error ("`...' in old-style identifier list");
		  yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, yyvsp[-1].ttype); }
break;
case 427:
#line 2403 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 428:
#line 2405 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 429:
#line 2411 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 430:
#line 2413 "../../../gccfe/gnu/c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 431:
#line 2418 "../../../gccfe/gnu/c-parse.y"
{ yyval.itype = pedantic;
		  pedantic = 0; }
break;
#line 4431 "c-parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
